    #include <bits/stdc++.h>

    using namespace std;

    const int Nmax=4*1e5;

    vector<int>edges[Nmax];
    vector<int>edgesinv[Nmax];
    int n;

    void debug_edges()
    {
        for (int i=1;i<=n;++i)
        {
            cout<<i<<": ";
            for (int j=0;j<edges[i].size();++j)
            {
                cout<<edges[i][j]<<" ";
            }
            cout<<'\n';
        }
    }

    string mas[Nmax];
    int masint[Nmax];
    string tree[4*Nmax]={""};

    void create(string &res,int a)
    {
        res="00000000000000000000";
        int i=0;
        while (a!=0)
        {
            res[res.size()-i-1]+=a%2;
            a/=2;
            ++i;
        }
    }

    void sum(string &cur,string a)
    {
        for (int i=0;i<cur.size();++i)
        {
            if (cur[i]=='d'||a[i]=='d'||(cur[i]!=a[i])) cur[i]='d';
        }
    }

    int get(string cur,int k)
    {
        --k;
        for (int i=cur.size()-1;i>=0;--i)
        {
            if (cur[i]=='d') cur[i]='0'+k%2;
            k=k/2;
        }
        if (k>0) return -1;
        int base=1;
        int res=0;
        for (int i=cur.size();--i;i>=0)
        {
            res+=(cur[i]-'0')*base;
            base=base<<1;
        }
        return res;
    }

    void oper (int v)
    {
        string res=mas[v];
        for (int i=0;i<edges[v].size();++i)
        {
            int u=edges[v][i];
            if (tree[u]=="") oper(u);
            sum(res,tree[u]);
        }
        tree[v]=res;
    }

    int main()
    {
        cin.tie(0);cout.tie(0);ios_base::sync_with_stdio(0);
        int a,b,c,g,t;
        cin>>n>>g;
        for (int i=0;i<n-1;++i)
        {
            cin>>a>>b;
            edges[a].push_back(b);
            edgesinv[b].push_back(a);
        }
        for (int i=1;i<=n;++i)
        {
            cin>>t;
            masint[i]=t;
            create(mas[i],t);
        }
        int root=-1;
        for (int i=1;i<=n;++i)
        {
            if (edgesinv[i].size()==0) root=i;
        }
        oper(root);
        int q,sw;
        cin>>q;
        for (int i=1;i<=q;++i)
        {
            cin>>sw>>a>>b;
            if (sw==2) cout<<get(tree[a],b)<<'\n';
        }
        return 0;
    }
