#include <cstdio>
#include <vector>
#include <algorithm>
#include <utility>

using namespace std;

int n, g;
vector<int> v[200000];

int main()
{
    scanf("%d%d", &n, &g);
    for (int i = 0; i < n; i++) {
        int a, b, c;
        scanf("%d%d%d", &a, &b, &c);
        a--;
        b--;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    int wt = -1; // vertex with three lines
    int wo = -1;
    for (int i = 0; i < n; i++) {
        if (v[i].size() == 3)
            wt = i;
        if (v[i].size() == 1)
            wo = i;
    }
    if (wt == -1) {
        printf("%d\n", n / 2);
        return 0;
    }
    // printf("%d %d\n", wt, wo);
    int prev = -1;
    int cur = wo;
    int cnt = 0;
    while(cur != wt) {
        int next;
        for (int to : v[cur]) {
            if (to != prev)
                next = to;
        }
        prev = cur;
        cur = next;
        cnt++;
    }
    // printf("%d\n", cnt);
    printf("%d\n", (n - cnt) / 2 + cnt);
    return 0;
}