#include <bits/stdc++.h>
using namespace std;

int search_len(int i, int j, vector<vector<int>>* graph, int len, int last)
{
    vector<int> lens;
    if(j == i)
    {
        return len;
    }
    for(int a = 1; a < graph->size(); a++)
    {
        if(a != last)
        {
            if((*graph)[j][a] != 0)
            {
                lens.push_back(search_len(i, a, graph, len + (*graph)[j][a], j));
            }
        }
    }
    sort(lens.begin(), lens.end());
    return(lens[0]);
}

int main() {
	int n, g;
    cin >> n >> g;
    
    vector<vector<int>> graph(n + 1, vector<int>(n + 1));
    for(int i = 0; i <= n; i ++)
    {
        graph[0][i] = i;
        graph[i][0] = i;
    }

    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) 
    {
        cin >> a[i] >> b[i] >> c[i];
        graph[a[i]][b[i]] = c[i];
        graph[b[i]][a[i]] = c[i];
    }

    vector<vector<int>> graph_paths = graph;

    for(int i = 1; i <= n; i ++)
    {
        for(int j = i + 1; j <= n; j ++)
        {
            if(graph_paths[i][j] == 0)
            {
                graph_paths[i][j] = search_len(i, j, &graph, 0, j);
            }
        }
    }
    int ans = 0;
    for(auto a : graph_paths)
    {
        for(auto b : a)
        {
            ans = max(ans, b);
        }
    }
    cout<<ans;
}
