#include <bits/stdc++.h>
using namespace std;

int search_len(int i, int j, vector<vector<int>>* graph, int len = 0, int last = -1)
{
    vector<int> lens;
    if(j == i)
    {
        return len;
    }
    for(int a = 1; a < graph->size(); a++)
    {
        if(a != last)
        {
            if((*graph)[j][a] != 0)
            {
                lens.push_back(search_len(i, a, graph, len + (*graph)[j][a], j));
            }
        }
    }
    sort(lens.begin(), lens.end());
    return(lens[0]);
}

int main()
{
    int n, g;
    cin >> n >> g;
    vector<vector<int>> roads(n+1, vector<int> (n + 1));
    for(int i = 0; i < n + 1; i++)
    {
        roads[i][0] = i;
        roads[0][i] = i;
    }

    int a, b, c;
    for(int i = 0; i < n; i++)
    {
        cin>>a>>b>>c;
        roads[a][b] = c;
        roads[b][a] = c;
    }
    vector<vector<int>>paths = roads;

    for(int i = 1; i < n + 1; i ++)
    {
        for(int j = i + 1; j < n + 1; j++)
        {
            if(roads[i][j] == 0)
            {
                paths[i][j] = search_len(i, j, &roads);
            }
        }
    }

    int ans = 0;
    for(auto a : paths)
    {
        for(auto b : a)
        {
            ans = max(b, ans);
        }
    }
    cout<<ans;
}