#include <bits/stdc++.h>

using namespace std;

#define INF (int)1e9
#define ll long long
#define vt vector
#define mp make_pair

void solve()
{
    int w, b;
    cin >> w >> b;

    if (w == b)
    {
        cout << 1 << " " << w + b << endl;
        for (int i = 0; i < w + b; i++)
        {
            cout << (i % 2 == 0 ? 'B' : 'W');
        }
        cout << endl;
    }
    else if((w == 0 && b == 0) && (min(w,b) == 0 && max(w,b) != 1)) {
        cout << -1 << endl;
    }
    else if(min(w, b) == 0 && max(w, b) == 1) {
        cout << 1 << " " << 1 << endl << (w > b ? 'W' : 'B') << endl;
    }
    else
    {
        char v[3][(min(w, b) * 2) + 1];

        char maxC, minC;
        if (w > b)
        {
            maxC = 'W';
            minC = 'B';
        }
        else
        {
            maxC = 'B';
            minC = 'W';
        }

        for (int i = 0; i < 3; i++)
        {
            for (int j = 0; j < min(w, b) * 2 + 1; j++)
            {
                v[i][j] = '.';
            }
        }

        bool end = false;
        pair<int, int> min_pos;
        min_pos = mp(1, 1);

        int maxCount = 0;
        bool minCount = true;

        for (int i = 0; i < min(w, b); i++)
        {
            if (maxCount == max(w, b) && minCount)
            {
                bool stop = false;

                for (int i = 0; i < 3; i += 2)
                {
                    for (int j = 0; j < min(w, b) * 2 + 1; j += 2)
                    {
                        if (v[i][j] == '.' && !stop)
                        {
                            if (i == 0)
                            {
                                if (v[i + 1][j] == maxC)
                                {
                                    v[i][j] = minC;
                                    stop = true;
                                }
                            }
                            else if (i == 2)
                            {
                                if (v[i - 1][j] == maxC)
                                {
                                    v[i][j] = minC;
                                    stop = true;
                                }
                            }
                        }
                    }
                }

                if (!stop)
                {
                    minCount = false;
                }
            }
            else
            {
                v[min_pos.first][min_pos.second] = minC;
                for (int j = min_pos.first - 1; j <= min_pos.first + 1; j++)
                {
                    for (int k = min_pos.second - 1; k <= min_pos.second + 1; k++)
                    {
                        if ((min_pos.first == j && k != min_pos.second) || (min_pos.second == k && j != min_pos.first))
                        {
                            if (v[j][k] == '.')
                            {
                                if (maxCount < max(w, b))
                                {
                                    v[j][k] = maxC;
                                    maxCount++;
                                }
                            }
                        }
                    }
                }

                min_pos = mp(min_pos.first, min_pos.second + 2);
            }
        }

        if (maxCount == max(w, b) && minCount)
        {
            cout << 3 << " " << min(w, b) * 2 + 1 << endl;

            for (int i = 0; i < 3; i++)
            {
                for (int j = 0; j < min(w, b) * 2 + 1; j++)
                {
                    cout << v[i][j];
                }
                cout << endl;
            }
        }
        else
        {
            cout << -1 << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}