#include <bits/stdc++.h>
using namespace std;

void dfs(int c, vector<vector<pair<int, int>>>& graph, vector<bool>& checked, int dist, int& max_dist) {
    checked[c] = true;
    if (dist > max_dist) {
        max_dist = dist;
    }
    for (int i = 0; i < graph[c].size(); i++) {
        pair<int, int> curr = graph[c][i];
        if (!checked[curr.first]) {
            dfs(curr.first, graph, checked, dist+curr.second, max_dist);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, g;
    cin >> n >> g;

    vector<vector<pair<int, int>>> a(n+2);
    for (int i = 0; i < n; i++) {
        int t1, t2, t3;
        cin >> t1 >> t2 >> t3;
        a[t1-1].push_back(make_pair(t2-1, t3));
        a[t2-1].push_back(make_pair(t1-1, t3));
    }
    int max_dist = -1;

    for (int i = 0; i < n; i++) {
        vector<bool> checked(n, false);
        dfs(i, a, checked, 0, max_dist);
    }
    cout << max_dist;
}
