#include <bits/stdc++.h>

#define MAX (200000 + 1)

typedef long long ll;

using namespace std;

struct edge{
    ll to;
    ll w;

    edge(ll _to, ll _w){
        to = _to;
        w = _w;
    }

};

vector<edge> g[MAX];
ll from[MAX];

ll n, group;

vector<ll> cycle;
stack<ll> dfs;
stack<ll> dfs_history;
void cycle_dfs(){
    dfs.push(1);
    ll prev, cur = -1;
    while(!dfs.empty()){
        while(from[dfs.top()] != 0 && from[dfs.top()] != -1)
            dfs.pop();
        prev = cur;
        cur = dfs.top();
        dfs.pop();
        dfs_history.push(cur);
        from[cur] = prev;
        for(ll i = 0; i < g[cur].size(); i++){
            ll next = g[cur][i].to;
            if(from[cur] != next){
                if(from[next] == 0){
                    dfs.push(next);
                }else{
                    cycle.push_back(next);
                    while(!dfs_history.empty() && dfs_history.top() != next){
                        cycle.push_back(dfs_history.top());
                        dfs_history.pop();
                    }
                    return;
                }
            }
        }
    }
    /*for(ll i = 0; i < g[cur].size(); i++){
        if(g[cur][i].to != prev){
            if(!visited[g[cur][i].to]){

                if(cycle_dfs(cur, g[cur][i].to))
                    return true;
            }else{
                cycle.push_back(g[cur][i].to);
                while(!dfs_history.empty() && dfs_history.top() != g[cur][i].to){
                    cycle.push_back(dfs_history.top());
                    dfs_history.pop();
                }
                return true;
            }
        }
    }
    return false;*/
}

vector<ll> lengths;
void solve(){
    cin >> n >> group;
    for(ll i = 0; i < n; i++){
        ll a, b, c;
        cin >> a >> b >> c;
        g[a].push_back({b, c});
        g[b].push_back({a, c});
    }
    cycle_dfs();
    if(group == 0){
        cout << 6 << endl;
    }else if(group == 1){
        ll sum_dst = 0;
        for(ll i = 0; i < g[cycle[cycle.size() - 1]].size(); i++){
            if(g[cycle[cycle.size() - 1]][i].to == cycle[0]){
                sum_dst += g[cycle[cycle.size() - 1]][i].w;
                lengths.push_back(g[cycle[cycle.size() - 1]][i].w);
            }
        }
        for(ll i = 0; i < cycle.size() - 1; i++){
            for(ll j = 0; j < g[cycle[i]].size(); j++){
                if(g[cycle[i]][j].to == cycle[i+1]){
                    sum_dst += g[cycle[i]][j].w;
                    lengths.push_back(g[cycle[i]][j].w);
                }
            }
        }
        ll mx = 0;
        ll temp_sum = 0;
        ll p1 = 0;
        for(ll p2 = 0; p2 < 2 * lengths.size(); p2++){
            if(temp_sum + lengths[p2 % lengths.size()] <= sum_dst / 2){
                temp_sum = temp_sum + lengths[p2 % lengths.size()];
                mx = max(mx, temp_sum);
            }else{
                while(p1 <= p2 && temp_sum + lengths[p2 % lengths.size()] > sum_dst / 2){
                    if(p1 < p2)
                        temp_sum -= lengths[p1 % lengths.size()];
                    p1++;
                }
                mx = max(mx, temp_sum);
            }
        }
        cout << mx << endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
