#include<bits/stdc++.h>
using namespace std;

void DFS(vector<pair<int, int>> graph[], int start, int prev, int &max, vector <bool> &visited)
{
	visited[start] = true;
	int length = 0;
	pair <int, int> child;
	for (int i = 0; i<graph[start].size(); i++)
	{
		child = graph[start][i];

		if (!visited[child.first])
		{
			length = prev + child.second;
			DFS(graph, child.first, length, max, visited);
		}

		if (length > max)
			max = length;

		length = 0;
	}
}

int main()
{
	int n, g, h1, h2, h3, ans = -999999999;
	cin >> n >> g;

	vector<pair<int, int>> graph[n + 1];

	for(int i = 0; i < n; ++i) {
		cin >> h1 >> h2 >> h3;
		graph[h1].push_back({h2, h3});
		graph[h2].push_back({h1, h3});
	}
	
	for(int i = 1; i <= n; ++i) {
		vector<bool> visited(n + 1, 0);
		DFS(graph, i, 0, ans, visited);
	}

	cout << ans << "\n";
	return 0;
}
