#include <bits/stdc++.h>
#include <iostream>
#include <vector>
using namespace std;

int Dijkstra(const int n, int st, const vector<vector<int>>& w)
{
    vector<bool> visited;
    vector<int> D;
    for (int i = 0; i < n; i++)
    {
        D.push_back(w[st][i]);
        visited.push_back(false);
    }
    D[st] = 0;
    int index = 0, u = 0;
    for (int i = 0; i < n; i++)
    {
        int min = INT_MAX;
        for (int j = 0; j < n; j++)
        {
            if (!visited[j] && D[j] < min)
            {
                min = D[j];
                index = j;
            }
        }
        u = index;
        visited[u] = true;
        for (int j = 0; j < n; j++)
        {
            if (!visited[j] && w[u][j] != INT_MAX && D[u] != INT_MAX && (D[u] + w[u][j] < D[j]))
            {
                D[j] = D[u] + w[u][j];
            }
        }
    }
    int mp = 0;
    for (int i = 0; i < n; i++)
    {
        if (D[i] != INT_MAX)
        {
            if (D[i] > mp)
                mp = D[i];
        }
    }
    return mp;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, g;
    cin >> n >> g;

    vector<int> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i];
    }

    int ans = 0;
    vector<vector<int >> w;
    for (int i = 0; i < n; i++)
    {
        vector<int> v;
        for (int j = 0; j < n; j++)
        {
            v.push_back(INT_MAX);
        }
        w.push_back(v);
    }

    for (int i = 0; i < n; i++) {
        int aa = a[i] - 1 , bb = b[i] - 1, cc = c[i];
        w[aa][bb] = w [bb][aa] = cc;
    }
    for(int k = 0; k < n; ++k)
    { 
        int m = Dijkstra(n, k, w);
        if (m > ans)
            ans = m;
    }
    cout << ans << endl;
}
