#include <bits/stdc++.h>

using namespace std;

const long long INF = LLONG_MAX;
const int N = 2 * 1e5 + 10;

vector < array < int , 2 > > g[N];
long long dist[N], val[N];
int p[N], used[N] = {0}, bg;
bool ok = false ;
vector < int > cycle, banned[N];
map < pair < int , int > , int > mp;
long long tmpp[N];

void dfs (int v, int par) {
    if (ok) return ;
    p[v] = par;
    used[v] = 1;
    for (auto i : g[v]) {
        if (ok) return ;
        if (i[0] == p[v]) continue ;
        if (used[i[0]] == 0)
            dfs (i[0], v);
        else if (used[i[0]] == 1) {
            p[i[0]] = v;
            bg = v;
            ok = true ;
            return ;
        }
    }
    used[v] = 2;
    return ;
}

set < int > toclear ;
long long deykstra (int n, int vv, int type) {
    toclear.clear ();
    int res = vv;
    long long mx = 0;
    dist[vv] = 0;
    priority_queue < array < long long , 2 > > q;
    q.push ({0, vv});
    while (!q.empty ()) {
        int v = q.top()[1];
        toclear.insert (v);
        q.pop ();
        for (auto i : g[v]) {
            bool good = true ;
            for (int bb : banned[v])
                if (bb == i[0])
                    good = false;
            if (good && dist[i[0]] > dist[v] + i[1]) {
            //    cout << v << " " << i[0] << "\n";
                dist[i[0]] = dist[v] + i[1];
                if (mx < dist[i[0]]) {
                    mx = dist[i[0]];
                    res = i[0];
                }
                q.push ({-dist[i[0]], i[0]});
            }
        }
    }
    //cout << "\n\n";
    if (type == 0) {
        val[vv] = mx;
        return res;
    }
    return mx;
}

long long t[4 * N], al[N], ar[N], nw[N], delta = 0;

void upd (int v, int l, int r, int p, long long val, bool type) {
    if (l == r) {
        if (type == 0) al[p] = val;
        else ar[p] = val;
        t[v] = min (al[p] - delta, ar[p] + delta) + nw[p];
        return ;
    }
    int m = l + r >> 1;
    if (p <= m) upd (v + v, l, m, p, val, type);
    else upd (v + v + 1, m + 1, r, p, val, type);
    t[v] = max (t[v + v], t[v + v + 1]);
    return ;
}

void build (int v, int l, int r) {
    if (l == r) {
        t[v] = min (al[l] - delta, ar[l] + delta) + nw[l];
        return ;
    }
    int m = l + r >> 1;
    build (v + v, l, m);
    build (v + v + 1, m + 1, r);
    t[v] = max (t[v + v], t[v + v + 1]);
    return ;
}

int main()
{
    int n, gg;
    cin >> n >> gg;
    for (int i = 0; i < n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back ({b, c});
        g[b].push_back ({a, c});
        mp[{min (a, b), max (a, b)}] = c;
    }
    dfs (1, 0);
    int tmp = p[bg];
    cycle.push_back (bg);
    while (tmp != bg) {
        cycle.push_back (tmp);
        tmp = p[tmp];
    }
    cycle.push_back (cycle [0]);
    cycle.push_back (cycle [1]);
    for (int i = 1; i + 1 < cycle.size(); ++i) {
        banned [cycle[i]].push_back (cycle[i - 1]);
        banned [cycle[i]].push_back (cycle[i + 1]);
    }
    cycle.pop_back ();
    cycle.pop_back ();
    long long ans = 0;
    for (int i = 1; i <= n; ++i) dist[i] = INF;
    for (int i : cycle) {
        int cc = deykstra (n, i, 0);
        for (int j : toclear) dist[j] = INF;
        ans = max (ans, deykstra (n, cc, 1));
    }
    long long sum = 0;
    int vert ;
    al[0] = ar[0] = 0;
    for (int i = 1; i < cycle.size(); ++i) {
        vert = mp[{min (cycle[i], cycle[i - 1]), max (cycle[i], cycle[i - 1])}];
        al[i] = al[i - 1] + vert;
        sum += vert;
    }

    n = cycle.size();
    vert = mp[{min (cycle[0], cycle[n - 1]), max (cycle[0], cycle[n - 1])}];
    ar[n - 1] = vert;
    for (int i = n - 2; i > 0; --i) {
        vert = mp[{min (cycle[i], cycle[i + 1]), max (cycle[i], cycle[i + 1])}];
        ar[i] = ar[i + 1] + vert;
    }
    for (int i = 0; i < n; ++i)
        nw[i] = val[cycle[i]];

    build (1, 0, n - 1);
    ans = max (ans, t[1]);
    for (int i = 1; i < n; ++i) {
        vert = mp[{min (cycle[i], cycle[i - 1]), max (cycle[i], cycle[i - 1])}];
        delta += vert;
        long long kl = al[i], kr = ar[i];
        upd (1, 0, n - 1, i, -kl + delta, 0);
        upd (1, 0, n - 1, i, -kr - delta, 1);
        upd (1, 0, n - 1, i - 1, sum - vert + delta, 0);
        upd (1, 0, n - 1, i - 1, vert - delta, 1);
        ans = max (ans, t[1]);
    }


    cout << ans << "\n";
    return 0;
}
