

#include <iostream>
#include <bits/stdc++.h>
#include <string>
#include <math.h>
#include <vector>
using namespace std;
long n;
long t;




int main() {
    
cin >> n >> t;


vector<vector< pair<int,int> >> graph(n + 1);

long ans = 0;


for (int i = 0; i < n; i++){
    int v1, v2, w;
    cin >> v1 >> v2 >> w;
    graph[v1].push_back(make_pair(v2, w));
    graph[v2].push_back(make_pair(v1, w));
}

for (int i = 1; i < n + 1; i++){
    
queue<int> q;
bool used[n + 1]{0};
long dist[n + 1]{0};


long firstV = i;
q.push(firstV);
used[firstV] = 1;

while (!q.empty()){
    int curV = q.front();
    q.pop();
    for (int i = 0; i < graph[curV].size(); i++){
        int foundV = graph[curV][i].first;
        
        if(!used[foundV]){
            used[foundV] = 1;
            q.push(foundV);
            dist[foundV] = dist[curV] + graph[curV][i].second;
        }
    }
    
    
}

for (int i = 1; i < n + 1; i++)
    if (dist[i] > ans)
        ans = dist[i];
}

cout << ans;
return 0;
}
