

#include <iostream>
#include <bits/stdc++.h>
#include <string>
#include <math.h>
#include <vector>
using namespace std;
long n;
long t;




int main() {
    
cin >> n >> t;


vector<vector< pair<int,int> >> graph(n + 1);

long ans = 0;

long genLen[n + 1][n + 1]{};


for (int i = 0; i < n; i++){
    int v1, v2, w;
    cin >> v1 >> v2 >> w;
    graph[v1].push_back(make_pair(v2, w));
    graph[v2].push_back(make_pair(v1, w));
}

for (int x = 1; x < n + 1; x++){
    
    queue<int> q;
    bool used[n + 1]{};
    long dist[n + 1]{};
    
    long firstV = x;
    
    for (int i = 1; i < n + 1; i++)
        if (genLen[i][x] > 0){
            used[i] = 1;
            for (int j = 0; j < graph[i].size(); j++)
                if (genLen[x][graph[i][j].first] == 0){
                    used[i] = 0;
                    break;
                }
                
            genLen[x][i] = genLen[i][x];
        }
                
    q.push(firstV);    
    used[firstV] = 1;
        
    while (!q.empty()){
        int curV = q.front();
        q.pop();
        for (int i = 0; i < graph[curV].size(); i++){
            int foundV = graph[curV][i].first;
                
            if(!used[foundV]){
                used[foundV] = 1;
                q.push(foundV);
                genLen[firstV][foundV] = genLen[firstV][curV] + graph[curV][i].second;
                if (genLen[firstV][foundV] > ans)
                    ans = genLen[firstV][foundV];
            }
        }
            
            
    }
    
    

}


cout << ans;
return 0;
}
