#include <bits/stdc++.h>

using namespace std;

const long long inf=1e18+1;

vector<vector<pair<long long, long long>>> v;
bitset<205> used;

long long dfs(long long a, long long b)
{
    used[a]=1;

    if(a==b)
    {
        return 0;
    }

    long long mn=inf;

    for(auto i=0; i<v[a].size(); i++)
    {
        if(!used[v[a][i].first])
        {
            mn=min(mn, v[a][i].second+dfs(v[a][i].first, b));
        }
    }

    return mn;
}

int main()
{
    long long n, g;

    cin>>n>>g;

    v.resize(n+1);

    for(auto i=0; i<n; i++)
    {
        long long a, b, c;

        cin>>a>>b>>c;

        a--;
        b--;

        v[a].push_back(make_pair(b, c));
        v[b].push_back(make_pair(a, c));
    }

    long long mxval=0;

    for(auto a=0; a<n; a++)
    {
        for(auto b=a+1; b<n; b++)
        {
            used.reset();

            long long cn=dfs(a, b);

            if(cn!=inf)
            {
                mxval=max(mxval, cn);
            }
            else
            {
                return -1;
            }
        }
    }

    cout<<mxval;

    return 0;
}
