#include <bits/stdc++.h>

using namespace std;

struct PathNode
{
    int prev = -1;
    long long value = INT_MAX;
};

PathNode path_temp[200001];
bool visited[200001] = { false };

long long max_dist(vector <vector<pair<int, int>>> graph, int a)
{
    for (int i = 0; i < graph.size(); i++)
    {
        visited[i] = false;
        path_temp[i].value = INT_MAX;
        path_temp[i].prev = -1;
    }
    int n_visited = 0;
    path_temp[a].value = 0;
    long long res = 0;
    while (n_visited != graph.size() - 1)
    {
        int minimum = 200000;
        for (int i = 1; i < graph.size(); i++)
            if (path_temp[i].value < path_temp[minimum].value && !visited[i])
                minimum = i;
        visited[minimum] = true;
        if (path_temp[minimum].value > res)
            res = path_temp[minimum].value;
        n_visited++;
        for (int i = 0; i < graph[minimum].size(); i++)
        {
            if (!visited[graph[minimum][i].first] && (graph[minimum][i].second + path_temp[minimum].value < path_temp[graph[minimum][i].first].value))
            {
                path_temp[graph[minimum][i].first].value = graph[minimum][i].second + path_temp[minimum].value;
                path_temp[graph[minimum][i].first].prev = minimum;
            }
        }
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n,g;
    cin >> n >> g;
    if (g == 1)
    {
        cout << n << '\n';
        return 0;
    }
    vector <vector<pair<int, int>>> graph(n + 1);
    for (int i = 0; i < n; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        graph[a].push_back(make_pair(b, c));
        graph[b].push_back(make_pair(a, c));
    }
    long long res = 0;
    for (int i = 1; i <= n; i++)
    {
        long long temp = max_dist(graph, i);
        if (temp > res)
            res = temp;
    }
    cout << res << '\n';
    return 0;
}