//#pragma GCC target("Ofast, unroll-loops")
//#pragma GCC optimize("avx, avx2, tune=native")

#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <numeric>
#include <iomanip>
#include <queue>

using namespace std;

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int w, b;
	cin >> w >> b;
	if (w == b)
	{
		cout << 1 << " " << 2 * w << '\n';
		for (int i = 0; i < w; ++i) cout << "WB";
		cout << '\n';
		return 0;
	}
	if (max(w, b) > (min(w, b) * 3 + 1))
	{
		cout << -1 << '\n';
		return 0;
	}
	vector<vector<char>> ans(3, vector<char>(2 * min(w, b) + 1, '.'));
	if (w > b)
	{
		ans[1][0] = 'W';
		for (int i = 0; i < b; ++i)
		{
			ans[1][2 * i + 1] = 'B';
			ans[1][2 * i + 2] = 'W';
		}
		int x = w - b - 1;
		for (int i = 1; i < (2 * b + 1) && x; i += 2)
		{
			--x;
			ans[0][i] = 'W';
		}
		for (int i = 1; i < (2 * b + 1) && x; i += 2)
		{
			--x;
			ans[2][i] = 'W';
		}
	}
	else
	{
		ans[1][0] = 'B';
		for (int i = 0; i < w; ++i)
		{
			ans[1][2 * i + 1] = 'W';
			ans[1][2 * i + 2] = 'B';
		}
		int x = b - w - 1;
		for (int i = 1; i < (2 * w + 1) && x; i += 2)
		{
			--x;
			ans[0][i] = 'B';
		}
		for (int i = 1; i < (2 * w + 1) && x; i += 2)
		{
			--x;
			ans[2][i] = 'B';
		}
	}
	cout << 3 << " " << 2 * min(b, w) + 1 << '\n';
	for (int i = 0; i < 3; ++i)
	{
		for (int j = 0; j < (2 * min(b, w) + 1); ++j) cout << ans[i][j];
		cout << '\n';
	}

	return 0;
}