n, g = [int(x) for x in input().split()]

infinity = 9223372036854775807
distances = [[infinity] * 200 for _ in range(200)]

node_count = 0
for i in range(n):
    a, b, c = [int(x) for x in input().split()]
    a, b = (a - 1), (b - 1)
    distances[a][b] = c
    distances[b][a] = c
    distances[a][a] = 0
    distances[b][b] = 0
    if max(a, b) + 1 > node_count:
        node_count = max(a, b) + 1

for k in range(node_count):
    for i in range(node_count):
        for j in range(node_count):
            if distances[i][j] > distances[i][k] + distances[k][j]:
                distances[i][j] = distances[i][k] + distances[k][j]

print(max([x for row in distances for x in row if x != infinity]))