from math import *
from queue import *

def read_line_int():
    return list(map(lambda x: int(x), input().split()))


n, g = [int(x) for x in input().split()]
ar = [[int(x) for x in input().split()] for _ in range(n)]


class Graph():
    def __init__(self, vin):
        self.v = vin
        self.edges = [[-1 for i in range(vin)] for j in range(vin)]
        self.visited = []

    def add_edge(self, u, v, weight):
        self.edges[u][v] = weight
        self.edges[v][u] = weight
    def dijkstra(self,start):
        self.visited=[]
        D = {v: inf for v in range(self.v)}
        D[start] = 0
        pq = PriorityQueue()
        pq.put((0, start))
        while not pq.empty():
            (d,tmp) = pq.get()
            self.visited.append(tmp)
            for i in range(self.v):
                if self.edges[tmp][i] != -1:
                    dist = self.edges[tmp][i]
                    if i not in self.visited:
                        old = D[i]
                        new = D[tmp] + dist
                        if new < old:
                            pq.put((new, i))
                            D[i] = new
        return D
test = Graph(n)
res=0
for edge in ar:
    test.add_edge(edge[0]-1,edge[1]-1,edge[2])
for i in range(n):
    e = max(test.dijkstra(i).items(),key=lambda x:x[1])[1]
    if res<e:
        res=e
print(res)