import math
n, _ = map(int,input().split())
matrix = [[0 for i in range(n)] for i in range(n)]
for i in range(n):
    a,b,c = map(int,input().split())
    matrix[a-1][b-1] = c
    matrix[b-1][a-1] = c


def connected(vertex,matrix):
    r=[]
    for i in range(n):
        if matrix[vertex][i] > 0:
            r.append(i)
    return r


def min_next(l,checked):
    min_ = -1
    m = max(l)
    for i in range(n):
        if i not in checked and m>l[i]:
            m=l[i]
            min_ = i
    return min_
answers = []
for v in range(n):
    #Dijkstra's algorithm
    l = [math.inf]*n
    l[v]=0
    checked = []
    checked.append(v)
    while v!=-1:
        connected_v = connected(v, matrix)
        for i in connected_v:
            if i not in checked:
                weight = l[v]+matrix[v][i]
                if weight<l[i]:
                    l[i] = weight
        v = min_next(l,checked)
        checked.append(v)
    answers.extend(l)
print(max(answers))
#If somebody sees this comment please help me!!!!  :()
