#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-fwhole-program")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-fstrict-overflow")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-skip-blocks")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("-funsafe-loop-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#undef _GLIBCXX_DEBUG

using namespace __gnu_pbds;
using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vd = vector<ld>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull = unsigned long long;

int mod=1e9+7;

int binpow (int a, int n)
{
	if (n == 0)
		return 1;
	if (n % 2 == 1)
		return ((binpow (a, n-1)%mod) * (a%mod))%mod;
	else
    {
		int b = (binpow (a, n/2))%mod;
		return (b * b)%mod;
	}
}



void solve()
{
    int n;
    string s;
    cin>>n>>s;
    vector<int> v;
    if(s[0]-s[n-1]==1)
    {
        int l2=n-1,r2=0;
        for(int i=1;i<n;i++)
        {
            if(s[i]-s[i-1]==1)
            {
                r2++;
            }
            else
            {
                break;
            }
        }
        for(int i=n-2;i>=0;i--)
        {
            if(s[i+1]-s[i]==1)
            {
                l2--;
                if(r2>=l2)
                {
                    cout<<n<<endl;
                    return;
                }
            }
            else
            {
                break;
            }
        }
        v.push_back(n-l2+r2+1);
        int l=r2+1,r=r2+1;
        for(int i=r2+2;i<l2;i++)
        {
            if(s[i]-s[i-1]==1)
            {
                r++;
            }
            else
            {
                v.push_back(r-l+1);
                l=i;
                r=i;
            }
            if(i==l2-1)
            {
                v.push_back(r-l+1);
            }
        }
    }
    else
    {
        int l=0,r=0;
        for(int i=1;i<n;i++)
        {
            if(s[i]-s[i-1]==1)
            {
                r++;
            }
            else
            {
                v.push_back(r-l+1);
                l=i;
                r=i;
            }
            if(i==n-1)
            {
                v.push_back(r-l+1);
            }
        }
    }
    sort(v.rbegin(),v.rend());
    cout<<v[0]<<endl;
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int z=1;
    //cin>>z;
    for(int q=0;q<z;q++)
    {
        solve();
    }
    return 0;
}
