#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>
#include <sstream>

using namespace std;

vector<vector<pair<int, int>>> ways;
vector<int> nums;

void Dive(int sp)
{
	for (int i = 0; i < ways[sp].size(); i++)
	{
		if (nums[sp] + ways[sp][i].second < nums[ways[sp][i].first])
		{
			nums[ways[sp][i].first] = nums[sp] + ways[sp][i].second;
			Dive(ways[sp][i].first);
		}
	}
}

int main()
{
	string s;
	bool b = false;
	while (getline(cin, s))
	{
		if (s == "")
		{
			if (b) break;
			b = true;
		}
		else
		{
			b = false;
			int n, inp;
			stringstream ss;
			ss << s;
			ss >> n >> inp;
			int nof1 = 0;
			ways = vector<vector<pair<int, int>>>(n);
			nums = vector<int>(n, INT_MAX);
			for (int i = 0; i < n; i++)
			{
				int ai, bi, ci;
				cin >> ai >> bi >> ci;
				ai--;
				bi--;
				ways[ai].push_back(pair<int, int>(bi, ci));
				ways[bi].push_back(pair<int, int>(ai, ci));
				if (ways[ai].size() == 1) nof1++;
				if (ways[ai].size() == 2) nof1--;
				if (ways[bi].size() == 1) nof1++;
				if (ways[bi].size() == 2) nof1--;
			}
			if (nof1 != 0)
			{
				int sp;
				for (sp = 0; sp < ways.size(); sp++)
				{
					if (ways[sp].size() == 1)break;
				}
				nums[sp] = 0;
				Dive(sp);
				cout << *max_element(nums.begin(), nums.end())<<"\n";
			}
			else
			{
				while (true)
				{

				}
			}
		}
	}
}