#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>
#include <sstream>

using namespace std;


int main()
{
    int ar[201][201];
    string s;
    bool b = false;
    while (getline(cin, s))
    {
        if (s == "")
        {
            if (b) break;
            b = true;
        }
        else
        {
            b = false;
            int n, inp;
            stringstream ss;
            ss << s;
            ss >> n >> inp;

            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    ar[i][j] = INT_MAX / 2;
                }
            }
            for (int i = 0; i < n; i++)
            {
                int ai, bi, ci;
                cin >> ai >> bi >> ci;
                ai--;
                bi--;
                ar[ai][bi] = ci;
                ar[bi][ai] = ci;
            }

            for (int f = 0; f < n; f++)
            {
                for (int i = 0; i < n; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        ar[i][j] = min(ar[i][f] + ar[f][j], ar[i][j]);
                    }
                }
            }
            int max = 0;
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    if (ar[i][j] < INT_MAX / 2) if (ar[i][j] > max) max = ar[i][j];
                }
            }
            cout << max << "\n";
        }
    }
    return 0;
}