
#include <algorithm>
#include <vector>
#include <string>
#include <iostream>
#include <map>
#include <cmath>
#include <climits>
#include <sstream>

using namespace std;

vector<vector<pair<long long int, long long int>>> ways;
vector<long long int> nums;

void Dive(long long int sp)
{
	for (long long int i = 0; i < ways[sp].size(); i++)
	{
		if (nums[sp] + ways[sp][i].second < nums[ways[sp][i].first])
		{
			nums[ways[sp][i].first] = nums[sp] + ways[sp][i].second;
			Dive(ways[sp][i].first);
		}
	}
}

int main()
{
	string s;
	bool b = false;
	vector<int> res;
			long long int n, inp;
			cin >> n >> inp;
			long long int nof1 = 0;
			ways = vector<vector<pair<long long int, long long int>>>(n);
			nums = vector<long long int>(n, INT_MAX);
			for (long long int i = 0; i < n; i++)
			{
				long long int ai, bi, ci;
				cin >> ai >> bi >> ci;
				ai--;
				bi--;
				ways[ai].push_back(pair<long long int, long long int>(bi, ci));
				ways[bi].push_back(pair<long long int, long long int>(ai, ci));
				if (ways[ai].size() == 1) nof1++;
				if (ways[ai].size() == 2) nof1--;
				if (ways[bi].size() == 1) nof1++;
				if (ways[bi].size() == 2) nof1--;
			}
			if (nof1 != 0)
			{
				long long int sp;
				for (sp = 0; sp < ways.size(); sp++)
				{
					if (ways[sp].size() == 1)break;
				}
				nums[sp] = 0;
				Dive(sp);
				cout<<*max_element(nums.begin(), nums.end());
			}
			else
			{
				while (true)
				{

				}
			}
}