fun main() {
    val line = readLine()!!.split(' ').map { it.toInt() }
    val n = line[0]
    val g = line[1]

    val inputs = mutableListOf<Input>()

    repeat(n) {
        val inp = readLine()!!.split(' ').map { it.toInt() }
        inputs.add(Input(inp[0], inp[1], inp[2]))
        inputs.add(Input(inp[1], inp[0], inp[2]))
    }

    val was = mutableListOf<Int>()
    inputs.forEach {
        if (!was.contains(it.start)) {
            algo(it.start, it.start, 0, inputs)
            was.add(it.start)
        }
    }

    var max = 0
    map.forEach {
        if (it.value > max) max = it.value
    }

    println(max)
}

val map = mutableMapOf<Pair<Int, Int>, Int>()

fun algo(start: Int, cur: Int, sum: Int, list: List<Input>) {
    map[start to cur]?.let {
        if (sum < it) map[start to cur] = sum
    } ?: run {
        map[start to cur] = sum
    }

    list.forEachIndexed { i, el ->
        if (el.start == cur) {
            val next = el.price + sum
            algo(start, el.end, next, list.drop(i))
        }
    }
}

data class Input(
    val start: Int,
    val end: Int,
    val price: Int
)