#include <iostream>
#include <string>

#include <vector>

using namespace::std;

int main() {
    
    int w, b;
    cin >> w >> b;

    if (max(w, b) > 3 * min(w, b) + 1) {
        cout << "-1\n";
        return 0;
    }

    vector<vector<int>> m(3, vector<int>(20, 0));

    for (int j = 0; j < 2 * min(w, b); j++) {
        if (j % 2 == 0) {
            m[1][j] = 1;
        }
        else {
            m[1][j] = 2;
        }
    }


    int left = max(w, b) - min(w, b);

    if (left != 0) {
        m[1][2 * min(w, b)] = 1;
        left -= 1;
    }


    for (int j = 0; j < 2 * min(w, b) && left > 0; j++) {
        if (j % 2 == 1) {
            m[0][j] = 1;
            left -= 1;
        }
    }

    for (int j = 0; j < 2 * min(w, b) && left > 0; j++) {
        if (j % 2 == 1) {
            m[2][j] = 1;
            left -= 1;
        }
    }


    char most, less;

    if (w > b) {
        most = 'W';
        less = 'B';
    }
    else {
        less = 'W';
        most = 'B';
    }


    int width = (max(w, b) - min(w, b)) > 0 ? 2 * min(w, b) + 1 : 2 * min(w, b);

    cout << 3 << " " << width << "\n";

    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < width; j++) {
            if (m[i][j] == 0) {
                cout << ".";
            }
            else if (m[i][j] == 1) {
                cout << most;
            }
            else {
                cout << less;
            }
        }
        cout << "\n";
    }

    return 0;    
}