#include <bits/stdc++.h>
using namespace std;
int dijkstra(vector<vector<pair<int, int>>> g, int s)
{
	vector<int> d(g.size(), 1e9);
	vector<bool> used(g.size());
	d[s] = 0;
	priority_queue<pair<int, int>> q;
	q.push({0, s});
	while (!q.empty())
	{
		int v = q.top().second;
		q.pop();
		if (!used[v])
			for (int i = 0; i < g[v].size(); i++)
			{
				pair<int, int> u = g[v][i];
				if (d[u.first] > d[v] + u.second)
				{
					d[u.first] = d[v] + u.second;
					q.push({d[u.first], u.first});
				}

			}
		used[v] = 1;
	}
	return *max_element(d.begin(),d.end());
}
int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	int n, a, b, c, ans=0;
	cin >> n >> a;
	vector<vector<pair<int, int>>> gr(n);

	for (int i = 0; i < n; ++i)
	{
		cin >> a >> b >> c;
		gr[--a].push_back({--b, c});
		gr[b].push_back({a, c});
	}
	vector<int> dist;
	for (int i = 0; i < n; ++i)
		ans = max(ans, dijkstra(gr, i));
	cout << ans;
	return 0;
}