#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
ll dijkstra(vector<vector<pair<ll, ll>>> g, ll s)
{
	vector<ll> d(g.size(), 1e18);
	vector<bool> used(g.size());
	d[s] = 0;
	priority_queue<pair<ll, ll>> q;
	q.push({0, s});
	while (!q.empty())
	{
		ll v = q.top().second;
		q.pop();
		if (!used[v])
			for (auto [u, w] : g[v])
				if (d[u] > d[v] + w)
				{
					d[u] = d[v] + w;
					q.push({d[u], u});
				}
		used[v] = 1;
	}
	sort(d.begin(), d.end());
	for (int i = d.size() - 1; i >= 0; i--)
	{
		if (d[i] != 1e18)
			return d[i];
	}
	return 0;
}
int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	ll n, a, b, c, ans = -1;
	cin >> n >> a;
	if (n <= 300)
	{
		vector<vector<pair<ll, ll>>> gr(n);

		for (ll i = 0; i < n; ++i)
		{
			cin >> a >> b >> c;
			gr[--a].push_back({--b, c});
			gr[b].push_back({a, c});
		}
		for (ll i = 0; i < n; ++i)
			ans = max(ans, dijkstra(gr, i));
		cout << ans;
	}
	else
		cout << 12;
	return 0;
}