#define _CRT_SECURE_NO_WARNINGS//MSVC compiler
#include <cstdio>//cstdio fan
#include <cmath>
#include <cstdint>
#include <algorithm>
#include <array>
#include <unordered_map>
#include <vector>
#include <set>
#include <limits>
using namespace std;

struct Node {
    unsigned m_parent = 0;
    unsigned value;
    std::set<unsigned> m_childs; 
};

std::vector<Node> tree;

void upd_tree(unsigned i) {
    for(auto j : tree[i].m_childs) {
        tree[j].m_parent = i;
        tree[j].m_childs.erase(i);
        upd_tree(j);
    }
}

std::vector<unsigned> vals;

void get_all_vals(unsigned i) {
    vals.push_back(tree[i].value);
    for(auto j : tree[i].m_childs) get_all_vals(j);
}

std::set<unsigned> F;

void calk_F(const std::vector<unsigned>& v) {
    if(v.size() == 1) F.insert(v.front());
    else {
        unsigned r = v.front();
        for(size_t i = 1; i < v.size(); i++) r ^= v[i];
        F.insert(r);
        for(size_t i = 0; i < v.size(); i++) {
            std::vector<unsigned> c = v;
            c.erase(c.begin() + i);
            calk_F(c);
        }
    }
}

int main() {
    unsigned n, g, q, t, ta, tb;
    scanf("%u%u", &n, &g);
    tree.resize(n);
    for(unsigned i = 1, a, b; i < n; i++) scanf("%u%u", &a, &b), --a, --b, tree[a].m_childs.insert(b), tree[b].m_childs.insert(a);//eraze
    upd_tree(0);
    for(unsigned i = 0, a; i < n; i++) scanf("%u", &a), tree[i].value = a;
    scanf("%u", &q);
    while(q--) {
        scanf("%u%u%u", &t, &ta, &tb);
        if(t == 1) tree[ta-1].value = tb;
        else {
            vals.clear();
            get_all_vals(ta-1);
            F.clear();
            calk_F(vals);
            if(tb > F.size()) {
                printf("-1\n");
                continue;
            }
            auto beg = F.begin();
            for(unsigned i = 1; i < tb; i++) beg++;
            printf("%u\n", *beg);
        }
    }
}