n, g = [int(x) for x in input().split()]
roads = [[int(x) for x in input().split()] for _ in range(n)]

nodes = range(1, n + 1)

graph = {i: None for i in range(1, n + 1)}
for cr_r_n in range(1, n + 1):
    values = {}
    for road in roads:
        if road[0] == cr_r_n:
            values.update({road[1]: road[2]})
        elif road[1] == cr_r_n:
            values.update({road[0]: road[2]})
    graph[cr_r_n] = values

all_paths = []

all_nodes = range(1, n + 1)
for i in all_nodes:
    not_vis = {node: float('inf') for node in nodes}
    vis = {}

    curr_dis = 0
    not_vis[i] = curr_dis

    while True:
        for neighbour, dis in graph[i].items():

            if neighbour not in not_vis:
                continue

            new_dis = curr_dis + dis
            if not_vis[neighbour] is float('inf') or not_vis[neighbour] > new_dis:
                not_vis[neighbour] = new_dis

        vis[i] = curr_dis
        del not_vis[i]

        if not not_vis:
            break

        all_variants = [node for node in not_vis.items() if node[1]]
        i, curr_dis = sorted(all_variants, key=lambda x: x[1])[0]

    all_paths.append(max(vis.values()))

print(max(all_paths))
