#include <bits/stdc++.h>
using namespace std;

const int MAX_V =1e4;

int dp[10000];
pair <int, int> cnt_len[10000];
int n;
vector < vector <int>> graph(10000);
int max_len_in_graph = 0;
bool used[1000];

void dfs(int node)
{
    used[node] = true;

    for (int i = 0; i < n; i++) {

        if (!used[graph[node][i]])
            dfs(graph[node][i]);
        dp[node] = max(dp[node], 1 + dp[graph[node][i]]);
    }
}
bool cmp(pair <int, int>  a, pair <int, int>  b)
{
    return a.second > b.second;
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int gr;
    cin >> n >> gr;
    int a, b, len;

    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            graph[i].push_back(0);


    for (int i = 0; i < n; i++)
	{
        cin >> a >> b >> len;
        a--;
        b--;
		graph[a][b] = len;
		graph[b][a] = len;
		cnt_len[a].second++;
		cnt_len[a].first = a;
		cnt_len[b].second++;
		cnt_len[b].first = b;
    }
    sort(cnt_len, cnt_len + n, cmp);
    int i = 0;
    while( i < n && cnt_len[i].second == cnt_len[0].second)
    {
        dfs(cnt_len[i].first);
        max_len_in_graph = max(max_len_in_graph, dp[cnt_len[i].first]);
        i++;
    }
    cout << max_len_in_graph << "\n";



}
