#include <bits/stdc++.h>
using namespace std;

char white = 'W' , black = 'B' , empty_ = '.';
const int height = 200 , width = 200;

void clearing_field(char field[][width]) {
	for (int i = 0; i < height; ++i)
		for (int j = 0; j < width; ++j)
			field[i][j] = empty_;
}

void filling_field_1(char field[][width] , int b , int w) { // первый способ
	int y = 0 , x = 0;
	if (b) field[0][0] = black;
	for (int i = 0; i < b - w; ++i) {
		++x; field[y][x] = white;
		++x; field[y][x] = black;
		--x; ++y; if (2*b - 3*w - i - 1) field[y][x] = black;
		--y; ++x;
	}
	if (b == w) x = -1;
	for (int i = 0; i < 2*w-b; ++i) {
		++x;
		field[y][x] = white;
		++x;
		field[y][x] = black;
	}
}

void filling_field_2(char field[][width] , int b , int w) {
	int y = 0 , x = 1;
	int b_copy = b;
	for (int i = 0; i < b/4; ++i) {
		if (i) {
			++x; field[y][x] = white; --w;
			++x;
		}
		field[y][x] = black; --b_copy;
		++y; --x; field[y][x] = black; --b_copy;
		++x; field[y][x] = white; --w;
		++x; field[y][x] = black; --b_copy;
		++y; --x; field[y][x] = black; --b_copy;
	}
	if (w) { ++x; field[y][x] = white; --w; }
	if (b_copy) { ++x; field[y][x] = black; --b_copy; }
	if (b_copy) { --x; ++y; field[y][x] = black; --b_copy; }
	if (w) { ++x; field[y][x] = white; --w; }
	if (b_copy) { ++x; field[y][x] = black; --b_copy; }
}

void output(char field[][width] , int a , int b) {
	cout << a << " " << b << endl;
	for (int i = 0; i < a; ++i) {
		for (int j = 0; j < b; ++j)
			cout << field[i][j];
		cout << endl;
	}
}

int w , b;
char field[height][width]{};
int main() {
	cin >> w >> b;

	if (w > b) {
		swap(w , b);
		swap(white , black);
	} // чтобы потом не искать кого больше, выберу что больше чорных,
	  // но если это не так то просто поменяю их символы заполнения и буду
	  // делать вид что черных больше

	if (b - w > 3 + w - 1) {
		cout << -1;
		return 0;
	} // нет фигуры такой
	
	if (!b) {
	    cout << "0 0";
	    return 0;
	} // пустая фигура

	clearing_field(field);

	int Y , X; //размеры нужного куска поля
	if (b <= 2*w+1) {
		if (b - w > 1) {
			Y = 2;
			X = 1 + (b - w)*2 + (2*w-b)*2;
		}
		else {
			Y = 1;
			X = b + w;
		}
		filling_field_1(field , b , w);
	}
	else {
		Y = 3 + (b/4-1) * 2;
		X = Y;
		filling_field_2(field , b , w);
	}

	output(field , Y , X);
	
	return 0;
}