#include <bits/stdc++.h>
using namespace std;

char white = 'W' , black = 'B' , empty_ = '.';
const int height = 200 , width = 200;

void clearing_field(char field[][width]) {
	for (int i = 0; i < height; ++i)
		for (int j = 0; j < width; ++j)
			field[i][j] = empty_;
}

void filling_field_1(char field[][width] , int b , int w) { // первый способ
    int x = 0;
    for (int i = 0; i < b*2; i += 2) {
        field[0][i] = black;
        field[0][i+1] = white;
    }
}

void filling_field_2(char field[][width] , int b , int w) { // второй способ
    int y = 0 , x = 0;
    field[0][0] = black;
    for (int i = 0; i < b-w-1; ++i) {
        ++x; field[y][x] = white;
        ++y; field[y][x] = black;
        --y; ++x; field[y][x] = black;
    }
    for (int i = 0; i < 2*w-b+1; ++i) {
        ++x; field[y][x] = white;
        ++x; field[y][x] = black;
    }
}

void filling_field_3(char field[][width] , int b , int w) { // третий способ
	int y = 0 , x = 0;
	for (int i = 0; i < b/2; ++i) {
	    if (i) field[y][x] = white;
	    ++x; field[y][x] = black;
	    --x; ++y; field[y][x] = black;
	    ++x;
	}
}

void output(char field[][width] , int a , int b) {
	cout << a << " " << b << endl;
	for (int i = 0; i < a; ++i) {
		for (int j = 0; j < b; ++j)
			cout << field[i][j];
		cout << endl;
	}
}

int w , b;
char field[height][width]{};
int main() {
	cin >> w >> b;

	if (w > b) {
		swap(w , b);
		swap(white , black);
	} // чтобы потом не искать кого больше, выберу что больше чорных,
	  // но если это не так то просто поменяю их символы заполнения и буду
	  // делать вид что черных больше
	  
	if (b > 2*w + 2   ||   b == 2 && w == 0) {
		cout << -1;
		return 0;
	} // нет фигуры такой
	
	if (!b) {
	    cout << "0 0";
	    return 0;
	} // пустая фигура
	
	

	clearing_field(field);

	int Y , X; //размеры нужного куска поля
	if (b == 2*w + 2) {
	    Y = 2 + (b/2-1);
	    X = Y;
	    filling_field_3(field , b , w);
	}
	else {
	    if (b == w) {
	        Y = 1;
	        X = b + w;
	        filling_field_1(field , b , w);
	    }
	    else {
	        Y = 2;
	        X = 2*w+1;
	        filling_field_2(field , b , w);
	    }
	}

	output(field , Y , X);
	
	return 0;
}