#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
//#pragma GCC optimize ("avx,avx2,tune=native")
#include <iostream>
#include <iomanip> 
#include <algorithm>
#include <set>
#include <unordered_map>
#include <vector>
#include <bitset>
#include <numeric>
#include <random>
#include <chrono>
#include <deque>
#include <map>
#include <queue>
#include <limits.h>
#define pb push_back
#define all(a) a.begin(),a.end()
#define mp make_pair
#define X first
#define Y second
#define sqr(x) ((x)*(x))
#define int long long
#define P 31

using namespace std;
//typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;

using namespace std;

constexpr int inf = 1e17 + 10;
constexpr int maxn = 2e5 + 10;
constexpr int mod = 1e9 + 7;

struct DSU
{
    int n;
    vector<int>p,am;
    DSU(int _n)
    {
        n=_n;
        am.assign(n+1,1);
        p.resize(n+1);
        iota(p.begin(),p.end(),0);
    }
    int get(int x)
    {
        if(p[x]==x)return x;
        return p[x]=get(p[x]);
    }
    void unite(int x,int y)
    {
        x=get(x);
        y=get(y);
        if(x!=y){p[x]=y;am[y]+=am[x];}
    }
};

int x;
vector <pii> graph [maxn];
vector <bool> redflag (maxn);
vector <int> a, b, cnt (maxn), z (maxn);
map <pii, int> mas;
int res = 0;

void dfs (int v, int par = -1){
    for (pii i: graph[v]) if (i.X != par){
        if (!redflag[i.X]) dfs (i.X, v);
        if (redflag[i.X]){
            mas [mp (v, i.X)] = mas [mp (i.X, v)] = i.Y;
            if (!redflag[v]) a.pb (v);
            redflag[v] = 1;
            continue;
        }
        res = max (res, z[v] + z[i.X] + i.Y);
        z[v] = max (z[v], z[i.X] + i.Y);
    }
}

multiset <int> q;

void solve (int &n, int g){
    DSU check(n + 1);
    int _a, _b, c;
    for (int i = 1; i <= n; ++i){
        cin >> _a >> _b >> c;
        if (check.get (_a) == check.get (_b)){
            x = _a;
        }
        check.unite (_a, _b);
        graph[_a].pb (mp (_b, c));
        graph[_b].pb (mp (_a, c));
    }
    redflag[x] = true;
    a.pb (x);
    dfs (x);
    int m = (int) a.size ();
    
    b.resize (m + 1);
    int s = 0;
    for (int i = 0; i < m - 1; ++i) b[i] = mas[mp (a[i], a[i + 1])], s += b[i];
    b[m - 1] = mas[mp (a[m - 1], a[0])];
    s += b[m - 1];
    /*for (int i = 0; i < m; ++i)
    {
        int f = 0;
        for (int j = 0; j < m - 1; ++j){
            f += b[(i + j) % m];
            //if (min(f, s - f) + z[a[i]] + z[a[(i + j + 1) % m]]) cout << f << ' ' << z[a[i]] + z[a[(i + j + 1) % m]] << '\n';
            res = max (res, min(f, s - f) + z[a[i]] + z[a[(i + j + 1) % m]]);
        }
    }*/
    
    int r = 0, s2 = 0;
    while (s2 + b[r] <= (s / 2)) s2 += b[r], r = (r + 1) % m, q.insert (s2 + z[a[r]]);
    int d = *q.rbegin();
    res = max (res, z[a[0]] + d);
    int p = 0;
    int s3 = 0;
    for (int i = 0; i < m; ++i) s3 += b[i], cnt[i] = s3 + z[a[(i + 1) % m]];
    for (int i = 1; i < m; ++i){
        p += b[i - 1];
        if (q.count (cnt[i - 1])) q.erase (q.find (cnt[i - 1]));
        if (b[i - 1] <= (s / 2)) s2 -= b[i - 1];
        else r = i;
        while (s2 + b[r] <= (s / 2)) s2 += b[r], q.insert (cnt[r]), r = (r + 1) % m;
        d = *q.rbegin();
        res = max (res, z[a[i]] + d - p);
    }
    
    reverse (all (a));
    b.resize (m);
    for (int i = 0; i < m - 1; ++i) b[i] = mas[mp (a[i], a[i + 1])];
    b[m - 1] = mas[mp (a[m - 1], a[0])];
    r = 0, s2 = 0;
    q.clear ();
    while (s2 + b[r] <= (s / 2)) s2 += b[r], r = (r + 1) % m, q.insert (s2 + z[a[r]]);
    d = *q.rbegin();
    res = max (res, z[a[0]] + d);
    p = 0;
    s3 = 0;
    for (int i = 0; i < m; ++i) s3 += b[i], cnt[i] = s3 + z[a[(i + 1) % m]];
    for (int i = 1; i < m; ++i){
        p += b[i - 1];
        if (q.count (cnt[i - 1])) q.erase (q.find (cnt[i - 1]));
        if (b[i - 1] <= (s / 2)) s2 -= b[i - 1];
        else r = i;
        while (s2 + b[r] <= (s / 2)) s2 += b[r], q.insert (cnt[r]), r = (r + 1) % m;
        d = *q.rbegin();
        res = max (res, z[a[i]] + d - p);
    }
    
    cout << res;
}

signed main (){
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int n, g;
    cin >> n >> g;
    solve (n, g);
    return 0;
}