#include <bits/stdc++.h>
using namespace std;

int mdistx(int n, int x, vector<vector<int>> &roads)
{
    int mx = 0, z;
    long long y;
    vector<int> dist(n, -1);
    dist[x] = 0;
    vector<int> q(n, -1);
    y = 1;
    q[0] = x;
    while (y!=0) {
        z = q[y-1];
        y--;
        for (int i=0; i<n; i++) {
            if (roads[z][i]>0 && ((dist[i] == -1) || (dist[i] > dist[z]+roads[z][i]))) {
                q[y] = i;
                y++;
                dist[i] = dist[z]+roads[z][i];
            }  
        }
    }
    for (int i=0; i<n; i++) {
        if (dist[i] > mx) {
            mx = dist[i];
        }
    }
    return mx;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, g;
    cin >> n >> g;

    vector<vector<int>> roads(n, vector<int>(n, 0));
    for (int i=0;i<n;i++) {
        int a, b, c;
        cin>>a>>b>>c;
        roads[a-1][b-1] = c;
        roads[b-1][a-1] = c;
    }

    int ans = 0, m;
    for (int i=0;i<n;i++) {
        m = mdistx(n, i, roads);
        if (m>ans) {
            ans = m;
        }
    }

    cout << ans << endl;

}
