#include <bits/stdc++.h>
using namespace std;

int mdistx(int n, int x, vector<int> nroads, vector<vector<vector<int>>> &roads)
{
    int mx = 0, z;
    long long y, si;
    vector<int> dist(n, -1);
    dist[x] = 0;
    vector<int> q(n, -1);
    si = n;
    y = 1;
    q[0] = x;
    while (y!=0) {
        z = q[y-1];
        y--;
        for (int i=0; i<nroads[z]; i++) {
            if ((dist[roads[z][i][0]] == -1) || (dist[roads[z][i][0]] > dist[z]+roads[z][i][1])) {
                q[y] = roads[z][i][0];
                y++;    
                dist[roads[z][i][0]] = dist[z]+roads[z][i][1];
            }  
        }
        if (y == si) {
            q.resize(si+1);
            si++;
        }
    }
    for (int i=0; i<n; i++) {
        if (dist[i] > mx) {
            mx = dist[i];
        }
    }
    return mx;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, g;
    cin >> n >> g;

    vector<int> nroads(n, 0);
    vector<vector<vector<int>>> roads(n);
    for (int i=0;i<n;i++) {
        int a, b, c;
        cin>>a>>b>>c;
        nroads[a-1]++;
        nroads[b-1]++;
        roads[a-1].push_back({b-1, c});
        roads[b-1].push_back({a-1, c});
    }

    int ans = 0, m;
    for (int i=0;i<n;i++) {
        m = mdistx(n, i, nroads, roads);
        if (m>ans) {
            ans = m;
        }
    }

    cout << ans << endl;

}
