//#pragma GGC optimize("O3,unroll-all-loops")
//#pragma GCC target("avx2,bmi,bmi2,popcnt,lzcnt")

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
constexpr ll N = 2e5+7;
char u[N];
bool C[N];
ll D[N];
vector<pair<int,ll>> g[N];
deque<int> li;
ll level[N];
vector<int> cycles;
int max_cl[N];
int n;
bool flag = false;
ll ans = 0;
struct segment_tree{
private:
    vector<ll> sgt_mx;
    vector<ll> sgt_mn;
    vector<ll> a;
    int n;
    void build(int v,int l,int r){
        if(l == r) sgt_mx[v] = a[l],sgt_mn[v] = a[l];
        else{
            build(v<<1,l,(l+r)>>1);
            build(v<<1|1,((l+r)>>1)+1,r);
            sgt_mx[v] = max(sgt_mx[v<<1],sgt_mx[v<<1|1]);
            sgt_mn[v] = min(sgt_mn[v<<1],sgt_mn[v<<1|1]);
        }
    }
    void update(int v,int l,int r,int t,ll val){
        if(t < l or t > r) return;
        if(l == r){
            sgt_mx[v] = val,sgt_mn[v] = val;
            return;
        }
        update(v<<1,l,(l+r)>>1,t,val);
        update(v<<1|1,((l+r)>>1)+1,r,t,val);
        sgt_mx[v] = max(sgt_mx[v<<1],sgt_mx[v<<1|1]);
        sgt_mn[v] = min(sgt_mn[v<<1],sgt_mn[v<<1|1]);
    }
    ll get_mx(int v,int l,int r,int tl,int tr){
        if(tl <= l and r <= tr) return sgt_mx[v];
        if(r < tl or tr < l) return -1e18;
        return max(get_mx(v<<1,l,(l+r)>>1,tl,tr),get_mx(v<<1|1,((l+r)>>1)+1,r,tl,tr));
    }
    ll get_mn(int v,int l,int r,int tl,int tr){
        if(tl <= l and r <= tr) return sgt_mn[v];
        if(r < tl or tr < l) return 1e18;
        return min(get_mn(v<<1,l,(l+r)>>1,tl,tr),get_mn(v<<1|1,((l+r)>>1)+1,r,tl,tr));
    }
    void update(int t,int val){
        update(1,0,n-1,t,val);
    }

public:
    segment_tree(){
        n = 0;
    }
    segment_tree(int N){
        n = N;
        sgt_mx.resize(4*N);
        sgt_mn.resize(4*N);
        a.resize(N);
    }
    segment_tree(vector<ll> A){
        a = A;
        n = A.size();
        sgt_mx.resize(4*N);
        sgt_mn.resize(4*N);
        build(1,0,n-1);
    }
    ll mx(int tl,int tr){
        if(tl > tr) return -1e18;
        return get_mx(1,0,n-1,tl,tr);
        //ll mx = -1e18;
        //for (int i = tl; i <= tr; ++i) {
        //    mx = max(mx,a[i]);
        //}
        //return mx;
    }
    void dbg(){
        for (int i = 0; i < n; ++i) {
            cout << a[i] << " ";
        }
        cout << "\n";
    }
};
void dfs2(int v,int p = -1){
    ll mx1 = 0,mx2 = 0;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if(to == p or C[to]) continue;
        dfs2(to,v);
        ll val = D[to]+g[v][i].second;
        if(val > mx1) mx2 = mx1,mx1 = val;
        else if(val > mx2) mx2 = val;
    }
    D[v] = mx1;
    ans = max(ans,mx1+mx2);
    return;
}
void dfs(int v,int p = -1){
    u[v] = 1;
    li.push_back(v);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i].first;
        if(u[to] == 2 or to == p) continue;
        if(u[to] == 1 and cycles.size() == 0){
            for (int j = li.size()-1; j >= 0; --j) {
                cycles.push_back(li[j]);
                if(li[j] == to) break;
            }
            return;
        }
        dfs(to,v);
        if(cycles.size()) return;
    }
    li.pop_back();
    u[v] = 2;
}

ll S;
inline ll dist(int u,int v){
    if(u <= v) return level[v]-level[u];
    else return S+level[v]-level[u];
}
inline void solve(){
    int G;
    cin >> n >> G;
    for (int i = 0; i < n; ++i) {
        int a,b;
        ll c;
        cin >> a >> b >> c;
        g[a].push_back({b,c});
        g[b].push_back({a,c});
    }
    dfs(1);
    int n_c = cycles.size();
    reverse(cycles.begin(),  cycles.end());
    for (int i = 0; i < n_c; ++i) {
        C[cycles[i]] = 1;
        //cout << cycles[i] << " ";
    }
    //cout << "\n";
    for (int i = 0; i < n_c; ++i) {
        dfs2(cycles[i]);
    }
    level[0] = 0;
    for (int i = 1; i < n_c; ++i) {
        for (int j = 0; j < g[cycles[i]].size(); ++j) {
            int to = g[cycles[i]][j].first;
            if(to == cycles[i-1]){
                level[i] = level[i-1]+g[cycles[i]][j].second;
                break;
            }
        }
    }
    for (int i = 0; i < g[cycles[0]].size(); ++i) {
        int to = g[cycles[0]][i].first;
        if(to == cycles[n_c-1]){
            S = level[n_c-1]+g[cycles[0]][i].second;
            break;
        }
    }

    //for (int i = 0; i < n_c; ++i) {
        //cout << D[cycles[i]] << " ";
    //}
    //cout << "\n";
    vector<ll> A;
    vector<ll> B;
    for (int i = 0; i < n_c; ++i) {
        int v = cycles[i];
        A.push_back({level[i]+D[v]});
        B.push_back({D[v]-level[i]});
    }
    segment_tree sum(A);
    segment_tree min(B);
    int p = 0;
    //for (int i = 0; i < n_c; ++i) {
        //cout << level[i] << " ";
   // }
    //cout << "\n";
    if(G == 3) return;
    for (int i = 0; i < n_c; ++i) {
        //cout << i << " ";
        while (dist(i,p) < S - dist(i,p)) p++,p%=n_c;
        p--;
        p = (p+n_c)%n_c;
        //cout << p << "\n";
        max_cl[i] = p;
    }
    ll ans2 = 0;
    for (int i = 0; i < n_c; ++i) {
        int v = cycles[i];
        ll ans1T = 0;
        ll ans2T = 0;
        ll ans3T = 0;
        ll ans4T = 0;
        if(max_cl[i] >= i){
             if(G != 3) ans1T = D[v]-level[i]+sum.mx(i+1,max_cl[i]);
        }
        else{
            ans1T = D[v]-level[i]+sum.mx(i+1,n_c-1);
            ans2T = D[v]-level[i]+S+sum.mx(0,max_cl[i]);
        }
        int next = (max_cl[i]+1)%n_c;
        if (next <= i){
            ans3T = D[v]+level[i]+min.mx(next,i-1);
        }else{
            ans3T = D[v]+level[i]+min.mx(0,i-1);
            ans4T = D[v]+level[i]+S+min.mx(next,n_c-1);
        }
        //cout << ans1T << " " << ans2T << " " << ans3T << " " << ans4T << "\n";
        ans2 = max({ans2,ans1T,ans2T,ans3T,ans4T});
    }
    cout << max(ans2,ans) << "\n";
}
int main(){
    ios_base::sync_with_stdio(false);cin.tie(nullptr);cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while(t--) solve();
}