#include <bits/stdc++.h>
using namespace std;
#define fast ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);
typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;
typedef vector <int> veci;
#define F first
#define S second
#define PB push_back
#define MP make_pair
#define fori(i, n) for(int i = 0;i < n;i++)
#define forn(i, n) for(int i = 1;i <= n;i++)
#define rfori(i, n) for(int i = n - 1;i >= 0;i--)
#define rforn(i, n) for(int i = n; i >= 1;i--)
#define multitest int t;cin>>t;while(t--) solve();
const ll mod = 1e9+7, N = 2e6+7, M = 2e6+7, INF = INT_MAX/10;

vector <vector <pii> > g;

veci dk(int s, int n)
{
    veci d (n + 1, INF),  p(n + 1);
	d[s] = 0;
	priority_queue < pii > q;
	q.push (MP(0, s));
	while (!q.empty())
    {
		int v = q.top().S,  cur_d = -q.top().F;
		q.pop();
		if (cur_d > d[v])  continue;
 
		fori(j, g[v].size())
        {
			int to = g[v][j].F;
			int w = g[v][j].S;
			if (d[v] + w < d[to])
            {
				d[to] = d[v] + w;
				p[to] = v;
				q.push (MP(-d[to], to));
			}
		}
	}
    return d;
}

int bfs(int s, int n)
{
    queue <int> q;
    q.push(s);
    vector <bool> used(n + 1);
    veci d(n + 1);
    d[s] = 0;
    used[s] = true;
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        fori(i, g[v].size())
        {
            ll to = g[v][i].F, w = g[v][i].S;
            if(!used[to])
            {
                d[to] = d[v] + w;
                used[to] = true;
                q.push(to);
            }
        }
    }
    int mx = -1;
    forn(i, n)
    {
        mx = max(mx, d[i]);
    }
    return mx;
}

void solve()
{
    int n, x;
    cin >> n >> x;
    g.resize(n + 1);

    fori(i, n)
    {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].PB(MP(b, c));
        g[b].PB(MP(a, c));
    }
    if(x == 1) 
    {
        cout << bfs(n, n);
        return;
    }
    veci d = dk(1, n);
    int mx = -1, ind;
    forn(i, n)
    {
        if(d[i] > mx)
        {
            mx = d[i];
            ind = i;
        }
    }
    veci d1 = dk(ind, n);
    mx = -1;
    forn(i, n)
    {
        mx = max(mx, d1[i]);
    }
    cout << mx;
}


signed main()
{
    fast;
    
    solve();

    return 0;
}