#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>
#include <stack>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<vector<pair<int,lli>>> graf;
vector<vector<pair<int, lli>>> graf2;
stack<int> st;
vector<int> used;
vector<int> used2;
vector<lli> cnt;

void func(int a)
{
    used2[a] = 1;
    while (st.top() != a) {
        used2[st.top()] = 1;
        st.pop();
    }
}


bool cycle(int a,int p)
{
    if (used[a] == 1) {
        func(a);
        return true;
    }
    st.push(a);
    used[a] = 1;
    for (int i = 0; i < graf[a].size(); i++) {
        if (graf[a][i].first != p) {
            if (cycle(graf[a][i].first, a)) return true;
        }
    }
    return false;
}

lli dfs(lli a, lli r) {
    used[a] = 1;
    for (int i = 0; i < graf[a].size(); i++) {
        if (used2[graf[a][i].first] == 0 && used[graf[a][i].first]==0) {
            cnt[a] = max(cnt[a], dfs(graf[a][i].first, graf[a][i].second));
        }
    }
    return cnt[a] + r;
}


lli work(int n)
{
    lli d = 0;
    for (int i = 1; i <= n; i++) {
        if (used2[i] == 1) {
            for (int j = 0; j < graf[i].size(); j++) {
                int x = graf[i][j].first;
                int y = graf[i][j].second;
                if (used2[x] == 1) {
                    graf2[i].push_back({ x, y });
                    d += y;
                }
            }
        }
    }
    return d;
}

lli dfs2(int a, lli f, lli l, lli d, int i)
{
    if (used[a] == 1 || l>d/2) return 0;
    used[a] = 1;
    lli x = dfs2(graf2[a][0].first, f,l + graf2[a][0].second, d,i);
    lli y = dfs2(graf2[a][1].first, f, l + graf2[a][1].second, d,i);
    lli z = max(x, y);
    lli w = l + f + cnt[a];
    if (a == i) w = 0;
    return max(w, z);
}

void solve()
{
    int n, g;
    cin >> n >> g;
    graf.resize(n + 1);
    graf2.resize(n + 1);
    used.resize(n + 1,0);
    cnt.resize(n + 1,0);
    used2.resize(n + 1,0);
    for (int i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        graf[a].push_back({ b,c });
        graf[b].push_back({ a,c });
    }
    cycle(1,1);


    used.clear();
    used.resize(n + 1,0);
    for (int i = 1; i <= n; i++) {
        if (used2[i] == 1) {
            dfs(i,0);
        }
    }

    lli d = work(n)/2;

    lli ans = 0;
    for (int i = 1; i <= n; i++) {
        if (used2[i] == 1) {
            used.clear();
            used.resize(n + 1, 0);
            ans = max(ans, dfs2(i, cnt[i], 0, d,i));
        }
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
}

