#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<vector<pair<int, lli>>> graf;
vector<int> used;
vector<lli> cnt;
queue<lli> q;

void dfs(int a, lli d,lli r)
{
    d = d + r;
    if (cnt[a] <= d) return;
    cnt[a] = d;
    for (int i = 0; i < graf[a].size(); i++) {
        dfs(graf[a][i].first, d, graf[a][i].second);
    }
}

lli work(int n)
{
    lli m = 0;
    for (int i = 1; i <= n; i++) {
        m = max(m, cnt[i]);
    }
    return m;
}

lli dfs2(int a,lli m, lli l,lli r, lli d)
{
    if (used[a] == 1) return 0;
    used[a] = 1;
    q.push(r);
    l += r;
    while (l > d) {
        l -= q.front();
        q.pop();
    }
    m = max(m, l);
    lli x = dfs2(graf[a][0].first, m, l, graf[a][0].second, d);
    lli y = dfs2(graf[a][1].first, m, l, graf[a][1].second, d);
    lli z = max(x, y);
    return max(m, z);
}

lli dfs3(int a, lli m, lli l, lli r, lli d)
{
    if (used[a] == 1) return 0;
    used[a] = 1;
    q.push(r);
    l += r;
    while (l > d) {
        l -= q.front();
        q.pop();
    }
    m = max(m, l);
    lli x = dfs2(graf[a][1].first, m, l, graf[a][1].second, d);
    lli y = dfs2(graf[a][0].first, m, l, graf[a][0].second, d);
    lli z = max(x, y);
    return max(m, z);
}

void solve2(int n)
{
    graf.resize(n + 1);
    used.resize(n + 1, 0);
    lli d=0;
    for (lli i = 0; i < n; i++) {
        lli a, b, c;
        cin >> a >> b >> c;
        d += c;
        graf[a].push_back({ b,c });
        graf[b].push_back({ a,c });
    }
    d = d / 2;
    lli ans = dfs2(1,0,0,0,d);
    ans = max(ans, dfs3(1, 0, 0, 0, d));
    cout << ans;
}


void solve()
{
    lli n, g;
    cin >> n >> g;
    if (g == 1) {
        solve2(n);
        return;
    }
    graf.resize(n + 1);
    used.resize(n + 1, 0);
    for (lli i = 0; i < n; i++) {
        lli a, b, c;
        cin >> a >> b >> c;
        graf[a].push_back({ b,c });
        graf[b].push_back({ a,c });
    }
    lli ans = 0;
    for (int i = 1; i <= n; i++) {
        cnt.clear();
        cnt.resize(n + 1, 10000000000000000);
        dfs(i,0,0);
        ans = max(ans, work(n));
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
}

