#include <bits/stdc++.h>

using namespace std;

struct bas {
    int basis[31];
    int num;

    int getKInd(int k) {
        int msk = 0, x = (1 << num);
        for (int i = 30; i >= 0; --i) {
            if (!basis[i]) {
                continue;
            }
            if (k <= (x >> 1)) {
                if (msk & (1 << i)) {
                    msk ^= basis[i];
                }
            } else {
                if (!(msk & (1 << i))) {
                    msk ^= basis[i];
                }
            }
            if (k > (x >> 1)) { // > 0
                k -= x >> 1;
            }
            x >>= 1;
        }
        return k == 1 ? msk : -1;
    }

    void add(int msk) {
        for (int i = 30; i >= 0; --i) {
            if (!(msk & 1 << i)) {
                continue;
            }
            if (basis[i]) {
                msk ^= basis[i];
                continue;
            }
            basis[i] = msk;
            ++num;
            return;
        }
    }
};


const int N = 5e4;
int a[N];

void dfs(int i, const vector<vector<int>>& gg, vector<bool>& isVisited, vector<vector<int>>& g, int p = -1) {
    if (isVisited[i]) {
        return;
    }
    isVisited[i] = true;
    if (p != -1) {
        g[p].push_back(i);
    }
    for (int j : gg[i]) {
        dfs(j, gg, isVisited, g, i);
    }
}

void calcNums(int i, const vector<vector<int>>& g, bas& b) {
    b.add(a[i]);
    for (auto j : g[i]) {
        calcNums(j, g, b);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, tt;
    cin >> n >> tt;
    vector<vector<int>> gg(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        gg[u].push_back(v);
        gg[v].push_back(u);
    }
    vector<bool> isVisited(n, false);
    vector<vector<int>> g(n);
    dfs(0, gg, isVisited, g);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    while (q--) {
        int type;
        cin >> type;
        if (type == 1) {
            int i, x;
            cin >> i >> x;
            --i;
            a[i] = x;
        } else {
            int i, k;
            cin >> i >> k;
            --i;
            bas b{};
            calcNums(i, g, b);
            cout << b.getKInd(k) << '\n';
        }
    }
    return 0;
}
