#include <bits/stdc++.h>
#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull=unsigned long long;

vl sz, parent;

ll find_set(ll v){
    if(v==parent[v]){
        return v;
    }
    return parent[v]=find_set(parent[v]);
}

void unite(ll a, ll b){
    a=find_set(a);
    b=find_set(b);
    if(a!=b){
        if(sz[a]<sz[b]) swap(a, b);
        parent[b]=a;
        sz[a]+=sz[b];
    }
}
vvpl g;
vl d;
void dfs(int v, int p=-1){
    for(auto to:g[v]){
        if(to.F!=p){
            d[to.F]=d[v]+to.S;
            dfs(to.F, v);
        }
    }
}
void solve()
{
    ll n, t;
    cin>>n>>t;
    g.rs(n+1);
    sz.rs(n+1);
    parent.rs(n+1);
    for(int i=1;i<=n;i++){
        sz[i]=1;
        parent[i]=i;
    }
    ll x, y, c, x1, y1, c1;
    for(int i=0;i<n;i++){
        cin>>x>>y>>c;
        if(find_set(x)!=find_set(y)){
            unite(x, y);
            g[x].pb({y, c});
            g[y].pb({x, c});
        }
        else{
            x1=x, y1=y, c1=c;
        }
    }
    d.rs(n+1);
    for(int i=1;i<=n;i++){
        d[i]=0;
    }
    dfs(1);
    ll zn=-1, vr=-1;
    for(int i=1;i<=n;i++){
        if(d[i]>zn){
            zn=d[i];
            vr=i;
        }
    }
    for(int i=1;i<=n;i++){
        d[i]=0;
    }
    dfs(vr);
    zn=-1, vr=-1;
    for(int i=1;i<=n;i++){
        zn=max(zn, d[i]);
    }
    ll ans=zn;
    cout<<ans<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
    //cin>>t;
    while (t--)
        solve();

}
/*

*/
