import java.util.*;

class Main
{
    private int V;
    private LinkedList<Integer> adj[];

    Main(int v)
    {
        V = v;
        adj = new LinkedList[v];
        for (int i=0; i<v; ++i)
            adj[i] = new LinkedList();
    }
    void addEdge(int v,int w)
    {
        adj[v].add(w);
    }
    int BFS(int s)
    {
        boolean visited[] = new boolean[V];
        LinkedList<Integer> queue = new LinkedList<Integer>();
        visited[s]=true;
        queue.add(s);
        int cnt = 0;
        while (queue.size() != 0)
        {
            s = queue.poll();
            cnt++;
            Iterator<Integer> i = adj[s].listIterator();
            while (i.hasNext())
            {
                int n = i.next();
                if (!visited[n])
                {
                    visited[n] = true;
                    queue.add(n);
                }
            }
        }
        return cnt;
    }

    public static void main(String args[])
    {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int gg = sc.nextInt();

        Main g = new Main(n);
        for (int i = 0; i < n; i++) {
            int source = sc.nextInt() - 1;
            int node = sc.nextInt() - 1;
            int val = sc.nextInt();
            g.addEdge(source, node);
            g.addEdge(node, source);
        }

        int max = 0;
        for (int i = 0; i < n; i++) {
            int x = g.BFS(i);
            if (max < x) max = x;
        }
        System.out.println(max);
    }
}
