#include <cstdio>
#include <algorithm>

const int N = 10000;
int n;
char s[N + 1];

inline int z(int i) {
	if (i >= n) i -= n;
	return i;
}

int main() {
	scanf("%d%s", &n, s);
	int ans = 0;
	for (int i = 0, j = 0; i < n; ++i) {
		j = std::max(j, i + 1);
		while (j < n + i && s[z(j)] == s[z(j - 1)] + 1) ++j;
		ans = std::max(ans, j - i);
	}
	printf("%d\n", ans);
	return 0;
}
