from itertools import combinations
def subsequences(s):
    out = set()
    for r in range(1, len(s) + 1):
        for c in combinations(s, r):
            out.add(c)
    return sorted(out)
def xorSum(s):
    m = len(s)
    k = s[0]
    for i in range(1, m):
        k ^= s[i]
    return k
def F(s):
    m = len(s)
    f = [0]
    for i in subsequences(s):
        f.append(xorSum(i))
    return f
n, g = map(int, input().split())
s = [[0 for i in range(n)] for j in range(n)]
for i in range(n-1):
    x, y = map(int, input().split())
    s[x-1][y-1] = 1
    s[y-1][x-1] = 1
a = list(map(int, input().split()))
for i in range(int(input())):
    request = list(map(int, input().split()))
    if request[0] == 1:
        a[request[1]-1] = request[2]
    else:
        k = request[2]
        h = []
        stack = [request[1]-1]
        visited = [False for _ in range(n)]
        visited[stack[-1]] = True
        while stack!=[]:
            top = stack[-1]
            for j in range(stack[0], n):
                if visited[j]==False and s[top][j]:
                    stack.append(j)
                    visited[j] = True
                    break
            else:
                h.append(a[stack[-1]])
                stack.pop()
        f = list(set(F(h)))
        if k > len(f):
            print(-1)
        else:
            print(f[k-1])