#include <cstdio>
#include <vector>
#include <algorithm>
#include <utility>
#include <climits>

using namespace std;

typedef unsigned long long ull;

int n, g;
ull a, b, c;
vector<vector<ull> > v(300, vector<ull>(300, ULONG_LONG_MAX));


int floyd()
{
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) 
            for (int j = 0; j < n; j++)
                if (v[i][k] != ULONG_LONG_MAX && v[k][j] != ULONG_LONG_MAX)
                    v[i][j] = min(v[i][j], v[i][k] + v[k][j]);
    }
    return 0;
}

int main()
{
    scanf("%d%d", &n, &g);
    for (int i = 0; i < n; i++) {
        scanf("%llu%llu%llu", &a, &b, &c);
        a--;
        b--;
        v[a][b] = c;
        v[b][a] = c;
    }
    floyd();
    ull maxi = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            maxi = max(maxi, v[i][j]);
    printf("%llu\n", maxi);
    return 0;
}