#include <bits/stdc++.h>

using namespace std;

#define INF (int)1e9
#define ll long long
#define vt vector
#define mp make_pair

void dfs(vt<pair<int,int> > v[], int index, int prev, int *max, vt<bool> &visited) 
{ 
  visited[index] = 1; 
   
  int current = 0; 
  pair <int, int> neighboring; 
  
  for (int i=0; i< v[index].size(); i++) 
  { 
     
    neighboring = v[index][i]; 

    if (!visited[neighboring.first]) 
    { 
      current = prev + neighboring.second; 
      dfs(v, neighboring.first, current, max, visited); 
    } 
    
     
    if ((*max) < current) 
      *max = current; 
     
    current = 0; 
  } 
} 
 
int longestPath(vt<pair<int,int> > v[], int n) 
{ 
   
  int max = INT_MIN; 
   
  for (int i=1; i<=n; i++) 
  { 
     
    vt< bool > visited(n+1, false); 
     
    dfs(v, i, 0, &max, visited); 
  } 
  return max; 
} 

void solve()
{
    int n, g;
    cin >> n >> g;

    vt<pair<int,int> > v[n+1]; 

    vt<int> l(n, -1);

    for (int i = 0; i < n; i++)
    {
        int a, b, c;
        cin >> a >> b >> c;
        v[a].push_back(make_pair(b, c));
        v[b].push_back(make_pair(a, c));
    }

    cout << longestPath(v, n); 

}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}