#include <bits/stdc++.h>
using namespace std;

void dfs(int c, vector<vector<pair<int, long long>>>& graph, vector<bool>& checked, int dist, int& max_dist, int t) {
    checked[c] = true;
    if (dist > max_dist) {
        max_dist = dist;
        //cout << t+1 << " " << c+1 << " " << dist << endl;
    }
    for (int i = 0; i < graph[c].size(); i++) {
        pair<int, int> curr = graph[c][i];
        if (!checked[curr.first]) {
            dfs(curr.first, graph, checked, dist+curr.second, max_dist, t);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, g;
    cin >> n >> g;

    vector<vector<pair<int, long long>>> a(n+2);
    for (int i = 0; i < n; i++) {
        int t1, t2;
        long long t3;
        cin >> t1 >> t2 >> t3;
        a[t1-1].push_back(make_pair(t2-1, t3));
        a[t2-1].push_back(make_pair(t1-1, t3));
    }
    // int max_dist = -1;

    // for (int i = 0; i < n+2; i++) {
    //     vector<bool> checked(n, false);
    //     dfs(i, a, checked, 0, max_dist, i);
    // }
    int m = 0;
    for (int i = 0; i < n+2; i++) {
        queue <int> q;
        q.push(i);
        vector <bool> checked(n+2, false);
        vector <int> ans(n+2, -1);
        checked[i] = true;
        ans[q.front()] = 0;
        while (!q.empty()) {
            for (int i = 0; i < a[q.front()].size(); i++) {
                pair<int, int> curr = a[q.front()][i];
                if (!checked[curr.first]) {
                    q.push(curr.first);
                    checked[curr.first] = true;
                    ans[curr.first] = ans[q.front()]+curr.second;
                }
            }
            q.pop();
        }
        int max_a = *max_element(ans.begin(), ans.end());
        if (m < max_a) {
            m = max_a;
        }
        // for (int i = 0; i < ans.size(); i++) {
        //     cout << ans[i] << " ";
        // }cout << endl;
    }
    
    cout << m;
}
