#define _FORTIFY_SOURCE 0
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
#pragma GCC optimize("inline")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-funroll-loops")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
#undef _GLIBCXX_DEBUG

#include<bits/stdc++.h>
using namespace std;

long long sum(vector<long long> pref, vector<long long> suf, int n, int l, int r){
	if(l<=r){
		if(l==0){
			return pref[r-1];
		}else{
			return pref[r-1]-pref[l-1];
		}
	}else{
		if(r==0){
			return suf[l];
		}else{
			return suf[l]+pref[r-1];
		}
	}
}

int main() {
	int n, g;
	cin>>n>>g;
	if(g==1){
		vector<long long> mas(n), pref(n), suf(n);
		vector<vector<pair<int, int> > > g(n);

		for(int i=0;i<n;i++){
			long long a, b, c;
			cin>>a>>b>>c;
			a--; b--;
			g[a].push_back(make_pair(b, c));
			g[b].push_back(make_pair(a, c));
		}
		vector<bool> used(n);
		int cur=0;
		used[0]=true;
		for(int i=0;i<n;i++){
			for(auto u:g[cur]){
				if(!used[u.first]||(u.first==0&&i>1)){
					mas[i] = u.second;
					used[u.first] = true;
					cur = u.first;
					break;
				}
			}
		}
		suf[n-1]=mas[n-1];
		for(int i=n-2;i>=0;i--){
			suf[i]=suf[i+1]+mas[i];
		}
		pref[0] = mas[0];
		for(int i=1;i<n;i++){
			pref[i] = pref[i-1]+mas[i];
		}
		long long ans = -1;
		for(int l=0;l<n-1;l++){
			for(int r=l+1;r<n;r++){
				ans=max(ans, min(sum(pref, suf, n, l, r), sum(pref, suf, n, r, l)));
			}
		}
		cout<<ans<<endl;
	}else{
	vector<vector<long long> > v(n);
	for(int i=0;i<n;i++){
		v[i].resize(n);
		for(int j=0;j<n;j++){
			v[i][j]=0;
		}
	}
	long long ans=0;
	for(int i=0;i<n;i++){
		long long a, b, c;
		cin>>a>>b>>c;
		a--; b--;
		v[a][b] = c;
		v[b][a] = c;
	}

	 
	for(int k=0; k<n; k++){
		for(int i=0; i<n; i++){
			for(int j=0; j<n; j++){
				if (v[i][k] && v[k][j] && i!=j){
					if (v[i][k]+v[k][j]<v[i][j] || v[i][j]==0){
						v[i][j]=v[i][k]+v[k][j];
						v[j][i]=v[i][j];
					}
				}

			}
		}
	}
	for(int i=0;i<n-1;i++){
		for(int j=i+1;j<n;j++){
			ans=max(ans, v[i][j]);
		}
	}
	cout<<ans<<endl;
	}

}
