#include <bits/stdc++.h>

//#pragma GCC optimize ("Ofast")
//#pragma GCC optimize ("unroll-loops")

using namespace std;

const int N=200100;
long long n, m, w, t, flag, c, x , y, vis[N], deep[N], dist[N], max_dist[N];
vector<pair<int, int>> g[N];
vector<long long> cycle, edges;
pair<long long, long long> pr[N];

long long g_1()
{
    cycle.push_back(1);
    edges.push_back(g[1][0].second);
    cycle.push_back(g[1][0].first);
    for (int i=1; i < n-1; i++)
    {
        if (g[cycle[i]][0].first != cycle[i-1])
        {
            cycle.push_back(g[cycle[i]][0].first);
            edges.push_back(g[cycle[i]][0].second);
        }
        else
        {
            cycle.push_back(g[cycle[i]][1].first);
            edges.push_back(g[cycle[i]][1].second);
        }
    }
    edges.push_back(g[1][1].second);
    edges.push_back(0);
    long long sum=0;
    for (int i=0; i<n; i++) sum+=edges[i];
    long long ans=0, p=0, dist=0;
    for (int i=0; i<n; i++)
    {
        if (edges[i] >= sum/2) return min(edges[i], sum - edges[i]);
    }
    for (int i=0; i<n; i++)
    {
        if ( i != 0)
            dist-=edges[i-1];
        while ((p <= n) && (dist + edges[p] <= sum/2))
        {
            dist += edges[p];
            p++;
        }
        if (min(sum/2 - dist, sum - dist - edges[p]) < abs(sum/2 - ans))
        {
            if (sum/2 - dist < sum - dist - edges[p])  ans = dist;
            else ans = dist + edges[p];
        }
    }
    return ans;
}

void find_cycle(int v, int& start, int& finish)
{
    for (int i=0; i<g[v].size(); i++)
    {
        int u = g[v][i].first;
        if (pr[u].first == 0)
        {
            pr[u].first = v;
            pr[u].second = g[v][i].second;
            find_cycle(u, start, finish);
        }
        else if ((u != pr[v].first) && (start == 0))
        {

            start = v;
            finish = u;
            //cout << start << " " << finish << "/" << '\n';
            cycle.push_back(u);
            edges.push_back(g[v][i].second);
        }
    }
}

void make_cycle(int v, int finish)
{
    //cout << v << '\n';
    vis[v] = 2;
    if ( v != finish)
    {
        cycle.push_back(v);
        edges.push_back(pr[v].second);
        make_cycle(pr[v].first, finish);
    }
}

void built_cycle()
{
    int start =0, finish =0;
    pr[1].first=1;
    pr[1].second =0;
    find_cycle(1, start, finish);
    make_cycle(start, finish);
}

void dfs(int v, int start)
{
    deep[v]=0;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i].first;
        if (vis[u] == 0)
        {
            vis[u] = 1;
            dist[u] = dist[v] + g[v][i].second;
            if (dist[u] > dist[max_dist[start]]) max_dist[start]=u;
            dfs(u, start);
            deep[v] = max(deep[v], deep[u] + g[v][i].second);
        }
    }
}

long long find_max(int v, int pr, int start)
{
    long long ans = 0;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i].first;
        if ((u != pr) && ((vis[u] == 1) || (u == start)))
        {
            long long ans1= find_max(u, v, start);
            ans = max(ans, ans1 + g[v][i].second);
        }
    }
    return ans;
}

long long g_2()
{
    built_cycle();
    //for (int i=0; i< cycle.size(); i++) cout << cycle[i] << " ";
    //cout << ":)" << '\n';
   
    long long ans = 0;
    for (int i=0; i<cycle.size(); i++)
    {
        dfs(cycle[i], cycle[i]);
        long long ans1= find_max(max_dist[cycle[i]], max_dist[cycle[i]], cycle[i]);
        ans = max(ans, ans1);
       // cout << ans1 << " ";
    }
    //cout << ":)" << '\n';
    // for (int i=0; i< cycle.size(); i++) cout << deep[cycle[i]] << " ";
    //cout << ":)" << '\n';
    //cout << ans << '\n';
    long long sum =0;
    for (int i=0; i < cycle.size(); i++) sum += edges[i];
    //cout << sum << '\n';
    for (int i=0; i<cycle.size() - 1; i++)
    {
        long long d = edges[i];
        for (int j=i+1; j<cycle.size(); j++)
        {
            long long k = min(sum - d, d);
            ans = max(ans, deep[cycle[i]] + deep[cycle[j]] + k);
            //cout << i << " " << j << " " << k << " " << ans << "  ";
            d+=edges[j];
        }
        

    }
    return ans;
}
int main()
{
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> m;
    for (int i=1; i<= n; i++)
    {
        cin >> x >> y >> c;
        pair<int, int> a;
        a.first=y;
        a.second=c;
        g[x].push_back(a);
        a.first=x;
        g[y].push_back(a);
    }
    if ( m == 1) cout << g_1() << '\n';
    else cout << g_2() << '\n';

    return 0;
}
