#include <bits/stdc++.h>

using namespace std;

#define x first
#define y second
#define pb push_back
#define all(a) a.begin(),a.end()
#define int long long

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int,int>pii;
typedef pair<ll,ll>pll;
typedef vector<ll>vll;
typedef vector<int>vi;
typedef vector<bool>vb;
typedef vector<vi>vvi;
typedef vector<vll>vvll;
typedef vector<pii>vpii;
typedef vector<pll>vpll;

const int N=2e5+99,inf=1e18;

vpii g[N];
vi v;
int dist[N];
bool used[N];

void dfs(int u){
    used[u]=1;
    for(auto[_w,to]:g[u]){
        if(!used[to]){
            v.pb(_w);
            dfs(to);
        }
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,G;
    cin>>n>>G;
    for(int i=1;i<=n;++i){
        int u,v,w;
        cin>>u>>v>>w;
        g[u].pb({w,v});
        g[v].pb({w,u});
    }
    if(G==1){
        int ans=0;
        for(int start=1;start<=n;++start){
            set<pii>st;
            st.insert({0,start});
            for(int i=1;i<=n;++i){
                if(i==start){
                    dist[i]=0;
                    continue;
                }
                dist[i]=inf;
                st.insert({dist[i],i});
            }
            while(!st.empty()){
                auto [d,v]=*st.begin();
                st.erase(st.begin());
                for(auto [w,to]:g[v]){
                    if(d+w<dist[to]){
                        st.erase(st.find({dist[to],to}));
                        dist[to]=d+w;
                        st.insert({dist[to],to});
                    }
                }
            }
            for(int to=1;to<=n;++to){
                ans=max(ans,dist[to]);
            }
        }
        cout<<ans;
    }
    if(G==2){
        dfs(1);
        int sum=0;
        for(auto _w:v){
            sum+=_w;
        }
        int sz=v.size();
        for(int i=0;i<sz;++i){
            v.pb(v[i]);
        }
        int r=0,cur=v[0],ans=0;
        for(int l=0;l<n;++l){
            r=max(r,l);
            while(cur<=sum-cur){
                r++;
                cur+=v[r];
            }
            if(r>l){
                ans=max(ans,cur);
            }
        }
        cout<<ans;
    }
}
