#include <bits/stdc++.h>

using namespace std;

const long long INF = LONG_LONG_MAX;
const int N = 2 * 1e5 + 1;
vector < array < int , 2 > > g[N];
long long dist[N];

void deykstra (int n, int vv) {
    for (int i = 1; i <= n; ++i) dist[i] = INF;
    dist[vv] = 0;
    priority_queue < array < long long , 2 > > q;
    q.push ({0, vv});
    while (!q.empty ()) {
        int v = q.top()[1];
        q.pop ();
        for (auto i : g[v]) {
            if (dist[i[0]] > dist[v] + i[1]) {
                dist[i[0]] = dist[v] + i[1];
                q.push ({-dist[i[0]], i[0]});
            }
        }
    }
    return ;
}

int main()
{
    int n, gg;
    cin >> n >> gg;
    for (int i = 0; i < n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back ({b, c});
        g[b].push_back ({a, c});
    }
    deykstra (n, 1);
    int p = 1;
    long long mx = 0;
    for (int i = 1; i <= n; ++i) {
        if (dist[i] > mx) {
            mx = dist[i];
            p = i;
        }
    }
    deykstra (n, p);
    mx = 0;
    for (int i = 1; i <= n; ++i)
        mx = max (mx, dist[i]);
    cout << mx << "\n";
    return 0;
}
