#include <bits/stdc++.h>

using namespace std;

const long long INF = LLONG_MAX;
const int N = 2 * 1e5 + 1;

vector < array < int , 2 > > g[N];
long long dist[N], val[N];
int p[N], used[N] = {0}, bg;
bool ok = false ;
vector < int > cycle, banned[N];
map < pair < int , int > , int > mp;
long long tmpp[N];

void dfs (int v, int par) {
    if (ok) return ;
    p[v] = par;
    used[v] = 1;
    for (auto i : g[v]) {
        if (i[0] == p[v]) continue ;
        if (used[i[0]] == 0)
            dfs (i[0], v);
        else if (used[i[0]] == 1) {
            p[i[0]] = v;
            bg = v;
            ok = true ;
            return ;
        }
    }
}

set < int > toclear ;
long long deykstra (int n, int vv, int type) {
    toclear.clear ();
    int res = vv;
    long long mx = 0;
    dist[vv] = 0;
    priority_queue < array < long long , 2 > > q;
    q.push ({0, vv});
    while (!q.empty ()) {
        int v = q.top()[1];
        toclear.insert (v);
        q.pop ();
        for (auto i : g[v]) {
            bool good = true ;
            for (int bb : banned[v])
                if (bb == i[0])
                    good = false;
            if (good && dist[i[0]] > dist[v] + i[1]) {
            //    cout << v << " " << i[0] << "\n";
                dist[i[0]] = dist[v] + i[1];
                if (mx < dist[i[0]]) {
                    mx = dist[i[0]];
                    res = i[0];
                }
                q.push ({-dist[i[0]], i[0]});
            }
        }
    }
    //cout << "\n\n";
    if (type == 0) {
        val[vv] = mx;
        return res;
    }
    return mx;
}

int main()
{
    int n, gg;
    cin >> n >> gg;
    for (int i = 0; i < n; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back ({b, c});
        g[b].push_back ({a, c});
        mp[{min (a, b), max (a, b)}] = c;
    }
    dfs (1, 0);
    int tmp = p[bg];
    cycle.push_back (bg);
    while (tmp != bg) {
        cycle.push_back (tmp);
        tmp = p[tmp];
    }
    if (cycle.size() < 3) {
        cout << "0\n";
        return 0;
    }
    cycle.push_back (cycle [0]);
    cycle.push_back (cycle [1]);
    for (int i = 1; i + 1 < cycle.size(); ++i) {
        banned [cycle[i]].push_back (cycle[i - 1]);
        banned [cycle[i]].push_back (cycle[i + 1]);
    }
  //  for (int i = 1; i <= n; ++i) {
   //     cout << i << "\n";
  //      for (int j : banned [i])
   //         cout << j << " ";
   //     cout << "\n\n";
  //  }
    cycle.pop_back ();
    cycle.pop_back ();
    long long ans = 0;
    for (int i = 1; i <= n; ++i) dist[i] = INF;
    for (int i : cycle) {
        int cc = deykstra (n, i, 0);
        for (int j : toclear) dist[j] = INF;
        ans = max (ans, deykstra (n, cc, 1));
    }
   // for (int i = 1; i <= n; ++i) cout << val[i] << " ";
   // cout << "\n";
   // for (int i : cycle) cout << i << " ";
   // cout << "\n";
    for (int i = 0; i < cycle.size(); ++i) {
        long long sum = 0;
        int pr = cycle[i];
        for (int j = i + 1; j < cycle.size(); ++j) {
            int vert = mp[{min (pr, cycle[j]), max (pr, cycle[j])}];
            sum += vert;
            tmpp[cycle[j]] = sum;
            pr = cycle [j];
        }
        for (int j = 0; j < i; ++j) {
            int vert = mp[{min (pr, cycle[j]), max (pr, cycle[j])}];
            sum += vert;
            tmpp[cycle[j]] = sum;
            pr = cycle [j];
        }
        pr = cycle[i];
        sum = 0;
        for (int j = i - 1; j >= 0; --j) {
            int vert = mp[{min (pr, cycle[j]), max (pr, cycle[j])}];
            sum += vert;
            tmpp[cycle[j]] = min(tmpp[cycle[j]], sum);
            pr = cycle [j];
        }
        for (int j = cycle.size() - 1; j > i; --j) {
            int vert = mp[{min (pr, cycle[j]), max (pr, cycle[j])}];
            sum += vert;
            tmpp[cycle[j]] = min(tmpp[cycle[j]], sum);
            pr = cycle [j];
        }
        for (int j : cycle) {
            if (j == cycle[i]) continue ;
            ans = max (ans, tmpp[j] + val[j] + val[cycle[i]]);
        }
    }
    cout << ans << "\n";
    /*deykstra (n, 1);
    int p = 1;
    long long mx = 0;
    for (int i = 1; i <= n; ++i) {
        if (dist[i] > mx) {
            mx = dist[i];
            p = i;
        }
    }
    deykstra (n, p);
    mx = 0;
    for (int i = 1; i <= n; ++i)
        mx = max (mx, dist[i]);
    cout << mx << "\n";*/
    return 0;
}
