

#include <iostream>
#include <bits/stdc++.h>
#include <string>
#include <math.h>
#include <vector>
using namespace std;
long n;
long t;

const long maxW = 100000000001;


int main() {
    
cin >> n >> t;


vector<vector< pair<int,int> >> graph(n + 1);

long ans = 0;

long genLen[n + 1][n + 1];

for (int i = 1; i < n + 1; i++)
    for (int j = 1; j < n + 1; j++)
        genLen[i][j] = maxW;
        
for (int i = 0; i < n; i++){
    int v1, v2, w;
    cin >> v1 >> v2 >> w;
    graph[v1].push_back(make_pair(v2, w));
    graph[v2].push_back(make_pair(v1, w));
}

for (int x = 1; x < n + 1; x++){
    
    bool used[n + 1]{};
    
    long firstV = x;
    
    for (int i = 1; i < n + 1; i++)
        if (genLen[i][x] > 0 and genLen[i][x] != maxW){
           used[i] = 1;
           for (int j = 0; j < graph[i].size(); j++)
               if (genLen[x][graph[i][j].first] == maxW){
                    used[i] = 0;
                    break;
                }
                
            
        }
                
    
    
    genLen[firstV][firstV] = 0;
    for (int i = 1; i < n + 1; i++){
		int curV = 0;
		
		for (int j = 1; j < n + 1; j++)
			if (!used[j] and (curV == 0 or genLen[firstV][j] < genLen[firstV][curV]))
				curV = j;
				
				
		
		if (genLen[firstV][curV] == maxW)
			break;
		
		
		used[curV] = 1;
 
		for (int j = 0; j < graph[curV].size(); j++){
		    
			long foundV = graph[curV][j].first;
			long dist = graph[curV][j].second;
			
			
			
			if (genLen[firstV][curV] + dist < genLen[firstV][foundV]){
			    
				genLen[firstV][foundV] = genLen[firstV][curV]  + dist;
				genLen[foundV][firstV] = genLen[firstV][foundV];
				if (genLen[firstV][foundV] > ans)
                    ans = genLen[firstV][foundV];
			}
			
		}
		
		
		
	}

}


cout << ans;
return 0;
}
