infinity = 9223372036854775807

n, g = [int(x) for x in input().split()]
distances = [[infinity] * n for _ in range(n)]

for i in range(n):
    a, b, c = [int(x) for x in input().split()]
    distances[a - 1][b - 1] = c
    distances[b - 1][a - 1] = c
    distances[a - 1][a - 1] = 0
    distances[b - 1][b - 1] = 0

for k in range(n):
    for i in range(n):
        for j in range(n):
            if (distances[i][j] == infinity) or (distances[i][j] > distances[i][k] + distances[k][j]):
                distances[i][j] = distances[i][k] + distances[k][j]

print(max([x for row in distances for x in row]))