#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <functional>
#include <string.h>
#include <queue>
#include <stdio.h>


using namespace std;

#define int long long


signed main(){
    int n,a;
    cin >> n >> a;
    if(a == 1){
        map<pair<int,int>, int> m;
        vector<vector<int> > v(n);
        for(int i=0;i<n;i++){
            int x,y,z;
            cin >> x >> y >> z;
            --x;
            --y;
            v[x].push_back(y);
            v[y].push_back(x);
            m[{x,y}] = z;
            m[{y,x}] = z;
        }
        queue<int> q;
        vector<bool> used(n);
        used[0] = 1;
        vector<int> dist(n,1e12);
        dist[0] = 0;
        q.push(0);
        while(q.size()){
            int x = q.front();
            q.pop();
            for(auto it: v[x]){
                if(used[it]) continue;
                used[it] = 1;
                dist[it] = dist[x]+m[{x,it}];
                q.push(it);
            }
        }
        int ans = 0;
    }
    if(a == 2){
        vector<pair<pair<int,int>,int> >v;
        for(int i = 0;i<n;i++){
            int x,y,z;
            cin >> x >> y >> z;
            --x;
            --y;
            v.push_back({{x,y},z});
            v.push_back({{y,x},z});
        }
        vector<vector<int> > dist(n,vector<int>(n,1e12));
        for(int i = 0;i<n;i++) dist[i][i] = 0;
        for(int i = 0;i<n;i++){
            bool p = 0;
            for(int j = 0;j<n;j++){
                for(int z = 0;z<v.size();z++){
                    if(dist[i][v[z].first.first] != 1e12){
                        if(dist[i][v[z].first.second] > (dist[i][v[z].first.first]+v[z].second)){
                            dist[i][v[z].first.second] = dist[i][v[z].first.first]+v[z].second;
                            p = 1;
                        }
                    }
                }
                if(!p) continue;
            }
        }
        int maxi = dist[0][0];
        for(int i = 0;i<n;i++){
            for(int z = 0;z<n;z++){
                if(i == z) continue;
                if(dist[i][z] != 1e12)
                    maxi = max(maxi,dist[i][z]);
            }
        }
        cout << maxi;
    }
    if(a == 4){
        return 1;
        vector<vector<pair<int,int> > > g(n);
        for(int i = 0;i<n;i++){
            int x,y,z;
            cin >> x >>y >> z;
            --x;
            --y;
            g[x].push_back({y,z});
            g[y].push_back({x,z});
        }
        vector<bool> used(n);
        vector<int> dist(n);
        dist[0] = 0;
        used[0] = 1;
        queue<int> q;
        q.push(0);
        while(q.size()){
            int x = q.front();
            q.pop();
            for(auto it : g[x]){
                if(used[it.first] && dist[it.first] > (dist[x]+1)){
                    q.push(it.first);
                    dist[it.first] = dist[x]+1;
                }
                if(!used[it.first]){
                    dist[it.first] = dist[x]+1;
                    used[it.first] = 1;
                    q.push(it.first);
                }
            }
        }
        int x = 0;
        for(int i = 1;i<n;i++){
            if(dist[x] < dist[i]) x = i;
        }
        used.clear();
        used = vector<bool>(n);
        dist.clear();
        dist = vector<int>(n);
        dist[0] = 0;
        used[0] = 1;
        q.push(0);
        while(q.size()){
            int x = q.front();
            q.pop();
            for(auto it : g[x]){
                if(used[it.first] && dist[it.first] > (dist[x]+1)){
                    q.push(it.first);
                    dist[it.first] = dist[x]+1;
                }
                if(!used[it.first]){
                    dist[it.first] = dist[x]+1;
                    used[it.first] = 1;
                    q.push(it.first);
                }
            }
        }
        x = 0;
        for(int i = 1;i<n;i++){
            if(dist[x] < dist[i]) x = i;
        }
        cout << dist[x];
        
    }
    
    cout << endl;
    
}
