#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <functional>
#include <string.h>
#include <queue>
#include <stdio.h>


using namespace std;

#define int long long

vector<set<int> > v;
vector<int> mass;

vector<vector<int> > vert;

void dfs_1(int x,int pr = -1){
    if(pr != -1)
        v[x].erase(pr);
    vector<int> s;
    s.push_back(x);
    for(auto it : v[x]){
        if(it != pr){
            dfs_1(it,x);
            for(auto itt:vert[it])
                s.push_back(itt);
        }
    }
    sort(s.begin(),s.end());
    vert[x] = s;
}

signed main(){
    int n,q;
    cin >> n >> q;
    if(q < 2){
        v.resize(n);
        mass.resize(n);
        for(int i = 1;i<n;i++){
            int x,y;
            cin >> x >> y;
            --x;
            --y;
            v[x].insert(y);
            v[y].insert(x);
        }
        vert.resize(n);
        dfs_1(0);
        
        for(auto & it : mass) cin >> it;
        int a;
        cin >> a;
        while(a--){
            int t,x,y;
            cin >> t >> x >> y;
            if(t ==  1){
                mass[x-1] = y;
            }
            else{
                x--;
                set<int> kk;
                kk.insert(0);
                for(int i = 0;i<pow(2,vert[x].size());i++){
                    int p = 0;
                    for(int z = 0;z<vert[x].size();z++){
                        if((1<<z)&i) p = (p^mass[vert[x][z]]);
                    }
                    kk.insert(p);
                }
                y--;
                while(y){
                    if(!kk.size()) break;
                    kk.erase(kk.begin());
                    y--;
                }
                if(kk.size()) cout << *kk.begin() << endl;
                else cout << 0-1 << endl;
            }
        }
        return 0;
    }
    v.resize(n);
    mass.resize(n);
    for(int i = 1;i<n;i++){
        int x,y;
        cin >> x >> y;
        --x;
        --y;
        v[x].insert(y);
        v[y].insert(x);
    }
    vert.resize(n);
    dfs_1(0);
    
    for(auto & it : mass) cin >> it;
    int a;
    cin >> a;
    while(a--){
        int t,x,y;
        cin >> t >> x >> y;
        if(t ==  1){
            mass[x-1] = y;
        }
        else{
            x--;
            set<int> vv;
            for(auto it : vert[x]) vv.insert(mass[it]);
            if(y > pow(2,vv.size())){
                cout << 0-1 << endl;
                continue;
            }
            y--;
            if(y == 0){
                cout << 0 << endl;
                continue;
            }
            string ss = "";
            while(y){
                ss += (y%2+'0');
                y /= 2;
            }
            int ans = 0;
            set<int>::iterator itt = vv.begin();
            for(int i = 0;i<min(vv.size(),ss.size());i++){
                if(ss[i] == '1') ans ^= (*itt);
                itt++;
            }
            cout << ans << endl;
            
            
        }
    }
    return 0;
    
    
    
}
