#include <bits/stdc++.h>
#define ll long long
#define fi first
#define se second
using namespace std;

int n, g;
ll mx=0;
vector<vector<pair<int, int> > > graph(201);
vector<ll> dist;

void Dijkstra(int v)
{
    priority_queue<pair<ll, int>, vector<pair<ll, int> >, greater<pair<ll, int> > > pq;
    pq.push({0, v});
    dist[v]=0;

    while(!pq.empty()){
        v=pq.top().se;
        pq.pop();
        for(auto p: graph[v]){
            int u=p.fi, w=p.se;
            if(dist[v]+w < dist[u]){
                dist[u]=dist[v]+w;
                pq.push({dist[u], u});
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> g;
    for(int i=0; i<n; i++){
        int a, b, c;
        cin >> a >> b >> c;
        graph[a].push_back({b, c});
        graph[b].push_back({a, c});
    }

    for(int i=1; i<=n; i++){
        dist.assign(n+1, LLONG_MAX);
        Dijkstra(i);
        for(int j=1; j<=n; j++){
            mx=max(mx, dist[j]);
        }
    }

    cout << mx;
    return 0;
}