#include <bits/stdc++.h>

using namespace std;
class Graph
{
   private:

   public:
       int v;
       vector<vector<int>> edges;
       vector <int> visited;
        Graph (int vin)
        {
            v=vin;
            for (int i=0; i<vin; i++)
            {
                vector <int> row;
                for (int j=0; j<vin; j++) row.push_back(-1);
                edges.push_back(row);
            }
        }
        void add_edge(int,int,int);
        int dijkstra(int);
};

void Graph::add_edge(int a,int b, int len)
{
    edges[a][b]=len;
    edges[b][a]=len;
}
struct compare
{
    bool operator()(vector <int> const& a, vector <int> const& b)
    {
        return a[0]<b[0];
    }
};
int Graph::dijkstra(int start)
{
    visited={};
    int res=-1;
    priority_queue <vector<int>,vector<vector<int>>,compare> pq;
    vector <int> row;
    pq.push({0,start});
    vector <vector<int>> D;
    for (int o = 0; o<v; o++)
        {
            D.push_back({o,2000000000});
        }
    D[start][1]=0;
    while (!pq.empty())
    {
        row=pq.top();
        int dist = row[0],current = row[1];
        pq.pop();
        visited.push_back(current);
        for (int i=0; i<v;i++)
        {
            if (edges[current][i]!=-1)
            {
                dist = edges[current][i];
                bool flag = 0;
                for (int y=0; y<visited.size();y++)
                {
                    if (visited[y]==i)
                    {
                        flag = 1;
                        break;
                    };
                };
                if (!flag)
                {
                    int old = D[i][1], ne = D[current][1] + dist;
                    if (ne<old)
                    {
                        pq.push({ne,i});
                        D[i][1]=ne;
                    }
                }
            }
        }
    }
    for (int i=0; i<v; i++)
    {
        if (D[i][1]>res) res=D[i][1];
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio();
    ifstream in("input.txt");
    in.tie(0);
    cin.tie(0);
    cout.tie(0);
    int tmp,n,g,a,b,c,res=0;
    in>>n>>g;
    Graph test(n);
    while (in>>a>>b>>c)
    {
        test.add_edge(a-1,b-1,c);
    }
    for (int i=0; i<test.v; i++)
    {
        tmp=test.dijkstra(i);
        if (res<tmp)
        {
            res=tmp;
        }
    }
    cout<<res;
    return 0;
}
