#include <bits/stdc++.h>
using namespace std;
vector<int> dijkstra(vector<vector<pair<int, int>>> g, int s)
{
	vector<int> d(g.size(), 1e9);
	vector<bool> used(g.size());
	d[s] = 0;
	priority_queue<pair<int, int>> q;
	q.push({0, s});
	while (!q.empty())
	{
		int v = q.top().second;
		q.pop();
		if (!used[v])
			for (auto [u, w] : g[v])
				if (d[u] > d[v] + w)
				{
					d[u] = d[v] + w;
					q.push({d[u], u});
				}
		used[v] = 1;
	}
	return d;
}
int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	int n, a, b, c, ans;
	cin >> n >> a;
	vector<vector<pair<int, int>>> gr(n);

	for (int i = 0; i < n; ++i)
	{
		cin >> a >> b >> c;
		gr[--a].push_back({--b, c});
		gr[b].push_back({a, c});
	}
	vector<int> dist;
	for (int i = 0; i < n; ++i)
	{
		dist=(dijkstra(gr, i));
		ans = max(ans, *max_element(dist.begin(), dist.end()));
}
	cout << ans;
	return 0;
}