#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
vector<int> dijkstra(vector<vector<pair<ll, ll>>> g, int s)
{
	vector<int> d(g.size(), 1e9);
	vector<bool> used(g.size());
	d[s] = 0;
	priority_queue<pair<int, int>> q;
	q.push({0, s});
	while (!q.empty())
	{
		int v = q.top().second;
		q.pop();
		if (!used[v])
			for (ll i = 0; i < g[v].size(); i++)
			{
				pair<ll, ll> u = g[v][i];
				if (d[u.first] > d[v] + u.second)
				{
					d[u.first] = d[v] + u.second;
					q.push({d[u.first], u.first});
				}
			}
		used[v] = 1;
	}
	return d;
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	ll ans, v = -1;
	ll n;
	cin >> n >> ans;
	vector<vector<pair<ll, ll>>> g(n);

	for (ll i = 0, a, b, c; i < n; ++i)
	{
		cin >> a >> b >> c;
		g[--a].push_back({--b, c});
		g[b].push_back({a, c});
	}
	for (int i = 0; i < n && v == -1; i++)
		if (g[i].size() == 1)
			v = i;
	vector<int> dist= dijkstra(g, v);
	cout << *max_element(dist.begin(), dist.end());
	return 0;
}