#include <bits/stdc++.h>
using namespace std;

const int MAX_V = 1e2;

int n;
int graph[MAX_V][MAX_V]= {0};
int max_len_in_graph = 0;
bool used[MAX_V];
int dp[MAX_V];

void Dijkstra(int st)
{
    int id, u;
    for (int i = 0; i < n; i++)
    {
        dp[i] = INT_MAX;
        used[i] = false;
    }
    dp[st] = 0;
    for (int i = 0; i < n - 1; i++)
    {
        int min_d=INT_MAX;
        for (int i = 0; i < n; i++)
            if (!used[i] && dp[i] <= min_d)
            {
                min_d = dp[i];
                id = i;
            }
        u = id;
        used[u] = true;
        for (int i = 0; i < n; i++)
            if (!used[i] && graph[u][i] && dp[u] != INT_MAX && dp[u]+graph[u][i]<dp[i])
                dp[i]=dp[u]+graph[u][i];
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int gr;
    cin >> n >> gr;

    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            graph[i][j] = MAX_V;


    int a, b, len;

    for (int i = 0; i < n; i++)
    {
        cin >> a >> b >> len;
        graph[a-1][b -1] = len;
        graph[b-1][a -1] = len;
    }

    for(int i = 0; i < n; i++)
    {
        Dijkstra(i);
        for(int j = i + 1; j < n; j++)
        {
            max_len_in_graph = max(max_len_in_graph, dp[j]);
        }
    }

    cout << max_len_in_graph << "\n";

}
