#include <iostream>
#include <iomanip> 
#include <algorithm>
#include <set>
#include <unordered_map>
#include <vector>
#include <bitset>
#include <numeric>
#include <random>
#include <chrono>
#include <deque>
#include <map>
#include <queue>
#include <limits.h>
#define pb push_back
#define all(a) a.begin(),a.end()
#define mp make_pair
#define X first
#define Y second
#define sqr(x) ((x)*(x))
#define int long long
#define P 31

using namespace std;
//typedef long long ll;
typedef long double ld;
typedef pair<int,int> pii;

using namespace std;

constexpr int inf = 1e17 + 10;
constexpr int maxn = 1e5 + 10;
constexpr int mod = 1e9 + 7;

vector <int> a (maxn), p (maxn), graph [maxn];
vector <int> basis [maxn];

void add (int v, int y){
    for (int x: basis[v]) y = min (y, y ^ x);
    if (y == 0) return;
    for (int &x: basis[v]) x = min (x, x ^ y);
    basis[v].pb (y);
    sort (all (basis[v]));
}

void dfs (int v, int par = -1){
    p[v] = par;
    basis[v].pb (a[v]);
    for (int i: graph[v]) if (i != par){
        dfs (i, v);
        for (int j: basis[i]) add (v, j);
    }
}

void solve (int &n){
    int t, x, y, q;
    for (int i = 1; i < n; ++i){
        cin >> x >> y;
        graph[x].pb (y);
        graph[y].pb (x);
    }
    for (int i = 1; i <= n; ++i) cin >> a[i];
    dfs (1);
    cin >> q;
    while (q--){
        cin >> t >> x >> y;
        if (t == 2){
            int r = (int) basis[x].size ();
            if ((1 << r) < y){
                cout << "-1\n";
                continue;
            }
            --y;
            int res = 0, h = 0;
            while (y){
                if (y % 2 == 1) res ^= basis[x][h];
                y >>= 1;
                ++h;
            }
            cout << res << '\n';
        }
    }
}

signed main (){
    ios_base::sync_with_stdio (false);
    cin.tie (nullptr);
    int n, g;
    cin >> n >> g;
    solve (n);
    return 0;
}