#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>

#define LF '\n'

using namespace std;
typedef long long int lli;

void solve()
{
    char arr[3][300];
    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 300; j++) {
            arr[i][j] = '.';
        }
    }
    int w, b;
    cin >> w >> b;
    int x = min(w, b);
    for (int i = 1; i <= 2*x; i+=2) arr[1][i] = 'B';
    for (int i = 2; i <= 2*x; i += 2) arr[1][i] = 'W';
    int y = max(w, b) - x;
    for (int i = 1; i <= 2 * x; i += 2) {
        if (y == 0) break;
        arr[0][i] = 'W';
        y--;
    }
    for (int i = 1; i <= 2 * x; i += 2) {
        if (y == 0) break;
        arr[2][i] = 'W';
        y--;
    }
    if (y > 0) {
        arr[1][0] = 'W';
        y--;
    }

    if (y > 0) {
        cout << -1;
        return;
    }
    if (w < b) {
        for (int i = 0; i < 3; i++) {
            for (int j = 0; j < 300; j++) {
                if (arr[i][j] == 'W') arr[i][j] = 'B';
                else if (arr[i][j] == 'B') arr[i][j] = 'W';
            }
        }
    }
    cout << 3 << " " << 300 << LF;
    for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 300; j++) {
            cout << arr[i][j];
        }
        cout << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
}

