#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

constexpr ll INF = 1000000000;

ll n, g, m, w, t;
vector< pair<ll, ll> > G[200000];
int main() {
    cin >> n >> g;
    vector<ll> a(n), b(n), c(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i];
        a[i]--;
        b[i]--;
        G[a[i]].push_back({b[i], c[i]});
        G[b[i]].push_back({a[i], c[i]});
    }
    ll d = -1;
    for (int i = 0; i < n; i++) {
        if (G[i].size() == 1) {
            d = i;
            break;
        }
    }
    if (d == -1) {
        d = 0;
    }
    vector<ll> dist0(n, INF);
    vector<bool> used0(n);
    dist0[d] = 0;
    priority_queue< pair<ll, ll> > pq;
    pq.push({0, d});
    while (!pq.empty()) {
        auto p = pq.top();
        pq.pop();
        ll x = p.second;
        if (used0[x]) {
            continue;
        }
        used0[x] = 1;
        for (auto i : G[x]) {
            if (!used0[i.first]) {
                dist0[i.first] = min(dist0[i.first], dist0[x] + i.second);
                pq.push({-dist0[x] - i.second, i.first});
            }
        }
    }
    ll f = 0;
    for (int i = 1; i < n; i++) {
        if (dist0[i] > dist0[f]) {
            f = i;
        }
    }
//    for (int i = 0; i < n; i++) {
//        cout << i << ": ";
//        for (auto j : G[i]) {
//            cout << j.first << ':' << j.second << ' ';
//        }
//        cout << '\n';
//    }
    vector<ll> distf(n, INF);
    vector<bool> usedf(n);
    distf[f] = 0;
    pq.push({0, f});
    while (!pq.empty()) {
        auto p = pq.top();
        pq.pop();
        ll x = p.second;
        if (usedf[x]) {
            continue;
        }
//        cout << x << '\n';
        usedf[x] = 1;
        for (auto i : G[x]) {
//            cout << x << ' ' << i.second << '\n';
            if (!usedf[i.first]) {
                distf[i.first] = min(distf[i.first], distf[x] + i.second);
                pq.push({-distf[x] - i.second, i.first});
            }
        }
    }
    ll e = 0;
    for (int i = 1; i < n; i++) {
        if (distf[i] > distf[e]) {
            e = i;
        }
//        cout << distf[i] << '\n';
    }
    cout << distf[e] << '\n';
}
