#include <bits/stdc++.h>
#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")

using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull=unsigned long long;

const ll INF=1e18;

vl used;
vl a;
vvpl g;
void dfs(int v, int tp=0){
    used[v]=1;
    for(auto to:g[v]){
        if(used[to.F]==0){
            a.pb(to.S);
            dfs(to.F, tp+1);
        }
        else if(to.F==1 && tp!=1){
            a.pb(to.S);
        }
    }
}


ll solve2(ll n, ll t, vl& x, vl& y, vl& c)
{
    vvl d(n, vl(n, INF));
    for(int i=0;i<n;i++){
        d[x[i]-1][y[i]-1]=c[i];
        d[y[i]-1][x[i]-1]=c[i];
    }
    for (int k=0; k<n; ++k)
        for (int i=0; i<n; ++i)
            for (int j=0; j<n; ++j)
                if (d[i][k] < INF && d[k][j] < INF)
                    d[i][j] = min (d[i][j], d[i][k] + d[k][j]);
    ll ans=0;
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
           // cout<<d[i][j]<<" ";
            if(d[i][j]<INF && i!=j){

                ans=max(ans, d[i][j]);
            }
        }
       // cout<<endl;
    }
    return ans;
}

ll solve1(ll n, ll t, vl& x, vl& y, vl& c)
{
    g.rs(n+1);
    used.rs(n+1);
    for(int i=0;i<n;i++){
        g[x[i]].pb({y[i], c[i]});
        g[y[i]].pb({x[i], c[i]});

    }
    if(t==0){
        return 6;
    }
    else if(t==1){
        dfs(1);
        vl pref(n+1);
        pref[0]=0;
        for(int i=0;i<n;i++){
            pref[i+1]=pref[i]+a[i];
        }
        ll ans=0;
        for(int i=0;i<n-1;i++){
            int l=i+1, r=n-1;
            while(r-l>0){
                int md=(l+r+1)/2;
                ll ans1=pref[md]-pref[i];
                ll ans2=pref[n]-ans1;
                if(ans1-ans2<=0){
                    l=md;
                }
                else{
                    r=md-1;
                }
            }
            if(((l+1)%n)!=i){
                ll ans1=pref[l]-pref[i];
                ll ans2=pref[n]-ans1;
                ans=max(ans, min(ans1, ans2));
                 ans1=pref[l+1]-pref[i];
                 ans2=pref[n]-ans1;
                ans=max(ans, min(ans1, ans2));
            }
        }
        g.clear();
        used.clear();
        a.clear();
        return ans;
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, t;
    cin>>n>>t;
    vl x(n), y(n), c(n);
    for(int i=0;i<n;i++){
        cin>>x[i]>>y[i]>>c[i];
    }
    if(t==0 || t==1){
        cout<<solve1(n, t, x, y, c)<<endl;
    }
    else if(t==2){
        cout<<solve2(n, t, x, y, c)<<endl;
    }
    else if(t==3){
       // cout<<solve3(n, t, x, y, c)<<endl;
    }
    else{
        //cout<<solve4(n, t, x, y, c)<<endl;
    }
}
/*
5 1
1 2 59
2 3 63
3 4 65
4 5 6
5 1 46
*/
