#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

int main(void)
{
    int w, b;
    size_t i;
    cin >> w >> b;
    if (max(w, b) > min(w, b) * 3 + 1) {
        cout << -1;
        return 0;
    }
    
    char field[3][200];
    for (i = 0; i < 3; i++)
        for (size_t j = 0; j < 200; j++)
            field[i][j] = '.';
    
    if (w > b) {
        for (i = 0; b != 0; i++) {
            if (i % 2 == 0) {
                field[1][i] = 'W';
                w--;
            }
            else {
                field[1][i] = 'B';
                b--;
            }
        }
        field[1][i] = 'W';
        w--;
    }
    else if (b > w) {
        for (i = 0; w != 0; i++) {
            if (i % 2 == 0) {
                field[1][i] = 'B';
                b--;
            }
            else {
                field[1][i] = 'W';
                w--;
            }
        }
        field[1][i] = 'B';
        b--;
    }
    else {
        for (i = 0; w + b != 0; i++) {
            if (i % 2 == 0) {
                field[1][i] = 'B';
                b--;
            }
            else {
                field[1][i] = 'W';
                w--;
            }
        }
    }
    
    size_t size = i;
    if (w != 0) {
        for (i = 1; i < size && w != 0; i += 2, w--)
            field[0][i] = 'W';
        
        if (w != 0)
            for (i = 1; i < size && w != 0; i += 2, w--)
                field[2][i] = 'W'; 
    }
    
    if (b != 0) {
        for (i = 1; i < size && b != 0; i += 2, b--)
            field[0][i] = 'B';
        
        if (b != 0)
            for (i = 1; i < size && b != 0; i += 2, b--)
                field[2][i] = 'B'; 
    }
    
    for (size_t i = 0; i < 3; i++) {
        for (size_t j = 0; j < 200; j++)
            cout << field[i][j];
        
        cout << endl;
    }
}