#include <iostream>
#include <vector>

using namespace std;
 
void search(vector<pair<int, int>>* res, vector<bool>& check, int start, int len, int& max)
{
    int buff = 0;
    check[start] = true;
    pair<int, int> con;
    for (size_t i = 0; i < res[start].size(); i++) {
        con = res[start][i];
        if (!check[con.first]) {
            buff = len + con.second;
            search(res, check, con.first, buff, max);
        }
        
        if (max < buff)
            max = buff;

        buff = 0;
    }
}
 
int main(void)
{
    int n, g;
    cin >> n >> g;
 
    vector<pair<int, int>> res[n+1];
 
    for (size_t i = 0; i < n; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        res[a].push_back(make_pair(b, c));
        res[b].push_back(make_pair(a, c));
    }
    
    
    int max = -1;
    for (size_t i = 1; i <= n; i++)
    {
        vector<bool> check(n+1, false);
        search(res, check, i, 0, max);
    }
    
    cout << max;
 
    return 0;
}
